#!/bin/bash

REPORT_NAME="DAILY REPORT"
if [ -n "$1" ]; then 
    REPORT_NAME=$1
fi;

MSG_BODY=`mktemp ./email_body_tmpXXXX`
SQL_EXE=/RouletteMaster/sqlexec.sh
SEND_EMAIL_TO_ALL=/RouletteMaster/send_email_to_all_finance.sh

#for which client; 192.168.0.0 means for all clients
CLIENT_IP=192.168.0.0

#counter index map
LIFETIME_IN=51
LIFETIME_OUT=52
LIFETIME_BET=53
LIFETIME_WIN=54
PAYOUT_ROUND=826

if [ -f /RouletteMaster/ROULETTE_NAME ]; then
    ROULETTE_NAME=`cat /RouletteMaster/ROULETTE_NAME`
else
    ROULETTE_NAME=`echo "select RES_STR_VALUE from GET_PARAM('192.168.0.254', 'ROULETTE_NAME', 11)" | $SQL_EXE|head -8|tail -1|sed -e 's/  *$//'`
    echo $ROULETTE_NAME > /RouletteMaster/ROULETTE_NAME
fi
            
TOTAL_IN=`echo "select cast(RES_COUNTER_VALUE as integer) from GET_DIGITAL_CNT('$CLIENT_IP', $LIFETIME_IN)" | $SQL_EXE|grep "[0-9]"|sed 's/^M$//'|sed 's/[ ^t]*$//'`
TOTAL_OUT=`echo "select cast(RES_COUNTER_VALUE as integer) from GET_DIGITAL_CNT('$CLIENT_IP', $LIFETIME_OUT)" | $SQL_EXE|grep "[0-9]"|sed 's/^M$//'|sed 's/[ ^t]*$//'`
TOTAL_BETS=`echo "select cast(RES_COUNTER_VALUE as integer) from GET_DIGITAL_CNT('$CLIENT_IP', $LIFETIME_BET)" | $SQL_EXE|grep "[0-9]"|sed 's/^M$//'|sed 's/[ ^t]*$//'`
TOTAL_WINS=`echo "select cast(RES_COUNTER_VALUE as integer) from GET_DIGITAL_CNT('$CLIENT_IP', $LIFETIME_WIN)" | $SQL_EXE|grep "[0-9]"|sed 's/^M$//'|sed 's/[ ^t]*$//'`
TOTAL_PAYOUT_ROUND_TOTAL=`echo "select cast(RES_COUNTER_VALUE as integer) from GET_DIGITAL_CNT('$CLIENT_IP', $PAYOUT_ROUND)" | $SQL_EXE|grep "[0-9]"|sed 's/^M$//'|sed 's/[ ^t]*$//'`
COUNTING_FROM=`echo "select RES_COUNTING_FROM from GET_DIGITAL_CNT('$CLIENT_IP', $LIFETIME_OUT)" | $SQL_EXE|head -6|tail -1|cut -c 0-10`
CREDIT_IS=`echo "select RES_NUM_VALUE from GET_PARAM('192.168.0.1', 'BILL_CREDIT_TO_CURRENCY', 11)" | $SQL_EXE|head -6|tail -1|sed 's/^M$//'|sed 's/[ ^t]*$//'`
MONEY_IS=`echo "select RES_NUM_VALUE from GET_PARAM('192.168.0.1', 'BILL_CURRENCY_TO_CREDIT', 11)" | $SQL_EXE|head -6|tail -1|sed 's/^M$//'|sed 's/[ ^t]*$//'`
CURRENCY=`echo "select RES_STR_VALUE from GET_PARAM('192.168.0.1', 'BILL_CURRENCY', 11)" | $SQL_EXE|head -6|tail -1|sed 's/^M$//'|sed 's/[ ^t]*$//'`

if [ "$CLIENT_IP" = "192.168.0.0" ]; then
    TITLE=$REPORT_NAME" for $ROULETTE_NAME\n\nToday is "`date +%F`
else
    PLAYBOARD=`echo $CLIENT_IP|cut -c 9-12`
    echo $REPORT_NAME" for Playboard$PLAYBOARD on $ROULETTE_NAME\n\n\tToday is "`date +%F`
fi

echo -e $TITLE > $MSG_BODY
echo >> $MSG_BODY
echo >> $MSG_BODY
echo >> $MSG_BODY
echo "*********************************************" >> $MSG_BODY
echo "*               S U M M A R Y               *">> $MSG_BODY
echo "*********************************************" >> $MSG_BODY
TMP_VALUE=`echo "scale=2; $TOTAL_IN*$MONEY_IS/$CREDIT_IS"|bc|xargs printf "%.2f"`
echo -e "TotaIN:\t\t\t\t $TMP_VALUE $CURRENCY" >> $MSG_BODY

TMP_VALUE=`echo "scale=2; $TOTAL_OUT*$MONEY_IS/$CREDIT_IS"|bc|xargs printf "%.2f"`
echo -e "TotalOUT:\t\t\t $TMP_VALUE $CURRENCY" >> $MSG_BODY

TMP_VALUE=`echo "scale=2; $TOTAL_BETS*$MONEY_IS/$CREDIT_IS"|bc|xargs printf "%.2f"`
echo -e "TotalBETS:\t\t\t $TMP_VALUE $CURRENCY" >> $MSG_BODY

TMP_VALUE=`echo "scale=2; $TOTAL_WINS*$MONEY_IS/$CREDIT_IS"|bc|xargs printf "%.2f"`
echo -e "TotalWINS:\t\t\t $TMP_VALUE $CURRENCY" >> $MSG_BODY

#echo -e "TotalROUNDED:\t\t\t $TOTAL_PAYOUT_ROUND_TOTAL credits" >> $MSG_BODY

echo >> $MSG_BODY
let PROFIT=TOTAL_BETS-TOTAL_WINS+TOTAL_PAYOUT_ROUND_TOTAL
PROFIT_M=`echo "scale=2; $PROFIT*$MONEY_IS/$CREDIT_IS"|bc|xargs printf "%.2f"`
echo -e "Total PROFIT is $PROFIT_M $CURRENCY" >> $MSG_BODY
echo  >> $MSG_BODY
#bet percent
if [ $TOTAL_BETS -gt 0 ]; then
    BET_PROFIT_PERCENT=`echo "scale=3; $PROFIT*100/$TOTAL_BETS"|bc|xargs printf "%.2f"`
else
    BET_PROFIT_PERCENT=0
fi
echo "Profit represents  $BET_PROFIT_PERCENT%  of all bets." >> $MSG_BODY
#payin percent
if [ $TOTAL_IN -gt 0 ]; then
    IN_PROFIT_PERCENT=`echo "scale=3; $PROFIT*100/$TOTAL_IN"|bc|xargs printf "%.2f"`
else
    IN_PROFIT_PERCENT=0
fi
echo "Profit represents  $IN_PROFIT_PERCENT%  of all payins." >>$MSG_BODY
echo >> $MSG_BODY
echo >> $MSG_BODY
echo >> $MSG_BODY
echo "**********************************************" >> $MSG_BODY
echo "*       D E T A I L E D    R E P O R T       *" >> $MSG_BODY
echo "*following values are in machine base credits*" >> $MSG_BODY
echo "**********************************************" >> $MSG_BODY
echo "select case CLIENT_IP
                  when '192.168.0.1' then 'PLAYBOARD 1' 
                  when '192.168.0.2' then 'PLAYBOARD 2' 
                  when '192.168.0.3' then 'PLAYBOARD 3'
                  when '192.168.0.4' then 'PLAYBOARD 4'
                  when '192.168.0.5' then 'PLAYBOARD 5'
                  when '192.168.0.6' then 'PLAYBOARD 6'
                  when '192.168.0.7' then 'PLAYBOARD 7'
                  when '192.168.0.8' then 'PLAYBOARD 8'
                  when '192.168.0.9' then 'PLAYBOARD 9'
                  when '192.168.0.10' then 'PLAYBOARD 10'
                  when '192.168.0.11' then 'PLAYBOARD 11'
                  when '192.168.0.12' then 'PLAYBOARD 12'
                  when '192.168.0.13' then 'PLAYBOARD 13'
                  when '192.168.0.14' then 'PLAYBOARD 14'
                  when '192.168.0.15' then 'PLAYBOARD 15'
                  else CLIENT_IP 
             end as CLIENT, 
             case COUNTER_INDEX 
	          when 51 then 'PAYIN'
	          when 52 then 'PAYOUT' 
	          when 53 then 'BETS' 
	          when 54 then 'WINS'
	          when 11 then 'CURRENT CREDIT '
	          when 12 then 'CURRENT RESTRICTED '
	          when 10 then 'CURRENT NONRESTRICTED'
	          when 13 then 'CURRENT FICHAS '
	          when 14 then 'CURRENT RESERVA '
	          when 15 then 'CURRENT BANCO '
	          else COUNTER_INDEX 
             end as COUNTER, 
             cast (COUNTER_VALUE as integer) as COUNTER_VALUE 
             from DIGITAL_COUNTERS 
             where COUNTER_INDEX=51 
                or COUNTER_INDEX=52 
                or COUNTER_INDEX=53 
                or COUNTER_INDEX=54
                or COUNTER_INDEX=10
                or COUNTER_INDEX=11
                or COUNTER_INDEX=12
                or COUNTER_INDEX=13
                or COUNTER_INDEX=14
                or COUNTER_INDEX=15
            order by CLIENT_IP descending,
                     COUNTER_INDEX ascending"| $SQL_EXE|sed '5,$!d'|sed '$d' >> $MSG_BODY
echo >> $MSG_BODY
echo >> $MSG_BODY
echo >> $MSG_BODY
echo "Detailed report values are displayed in credits, where" >> $MSG_BODY
echo "$MONEY_IS $CURRENCY is $CREDIT_IS credits." >>$MSG_BODY
echo >> $MSG_BODY
echo "Values are from $COUNTING_FROM until "`date +%F` >> $MSG_BODY
echo >> $MSG_BODY

fbexport -Sh -d /ROULETTE_DATA.GDB -p masteraloha -q "select * from LOG_TOTALS_ALL(0)" -f /RouletteMaster/eml_attach/finance.html

cat $MSG_BODY | $SEND_EMAIL_TO_ALL "$REPORT_NAME"
rm $MSG_BODY -rf
exit 0
