set term ^ ;
ALTER PROCEDURE RESET_DIGITAL_CNT(
  VAR_COUNTER_INDEX INTEGER)
AS
declare variable tmp_counter_value BIGINT;
BEGIN
if ( VAR_COUNTER_INDEX is null
    ) then
    begin
         execute procedure WRITE_LOG('DB', 0, 101400, 'ERROR: Trying to reset counter, with invalid input parameters. Nothing done.');
         suspend;
         exit;
    end

    /* prej je bil delete from, zdaj pa naredimo =0, zato da counting from dobi trenutni timestamp */
    update DIGITAL_COUNTERS
    set    DIGITAL_COUNTERS.counter_value = 0,
           DIGITAL_COUNTERS.COUNTING_FROM = current_timestamp
    where  /*DIGITAL_COUNTERS.client_ip = :VAR_CLIENT_IP
    and  */DIGITAL_COUNTERS.counter_index = :VAR_COUNTER_INDEX;

  SUSPEND;
END;
^

CREATE or ALTER PROCEDURE J_STATUS(
  VAR_JACKPOT_ID VARCHAR(40) CHARACTER SET WIN1250)
RETURNS(
  RES_POT_VALUE_CENTS BIGINT,
  RES_RELOAD_POT_VALUE_CENTS BIGINT,
  RES_JACKPOT_STATUS VARCHAR(10) CHARACTER SET WIN1250,
  RES_CLIENTS_IN INTEGER,
  RES_CLIENTS_WIN INTEGER,
  RES_CLIENTS_TIMEOUT INTEGER,
  RES_CLIENTS_OUT INTEGER,
  RES_RESULT SMALLINT,
  RES_CAPTION VARCHAR(100) CHARACTER SET WIN1250,
  RES_LUCKY_NUMBER INTEGER)
AS
DECLARE VARIABLE TMP_JACKPOT_STATUS VARCHAR(10);
BEGIN
  /* Procedure body */

  if ( VAR_JACKPOT_ID is null
  ) then
  begin
       RES_RESULT = -1;
       RES_CAPTION = 'Invalid input parameters';
       suspend;
       exit;
  end

  select POT_VALUE_MONEY*100,
         POT_RELOAD_MONEY*100,
         STATUS
  from JACKPOT_PHASE_DATA
  where JACKPOT_ID = :VAR_JACKPOT_ID
  into :RES_POT_VALUE_CENTS,
       :RES_RELOAD_POT_VALUE_CENTS,
       :RES_JACKPOT_STATUS;
  if ( RES_JACKPOT_STATUS is null ) then
  begin
       RES_CAPTION = :VAR_JACKPOT_ID||' jackpot was reset.';
       RES_POT_VALUE_CENTS = 0;
       RES_RELOAD_POT_VALUE_CENTS = 0;
       RES_JACKPOT_STATUS = 'RESET';
       RES_CLIENTS_IN = 0;
       RES_CLIENTS_WIN = 0;
       RES_CLIENTS_TIMEOUT = 0;
       RES_CLIENTS_OUT = 0;
       RES_RESULT = -2;
       SUSPEND;
       EXIT;
  end

  select count(STATUS)
  from JACKPOT_CLIENTS
  where STATUS = 'IN'
  and JACKPOT_ID=:VAR_JACKPOT_ID
  into :RES_CLIENTS_IN;

  select count(STATUS)
  from JACKPOT_CLIENTS
  where STATUS = 'WIN'
  and JACKPOT_ID=:VAR_JACKPOT_ID
  into :RES_CLIENTS_WIN;

  select count(STATUS)
  from JACKPOT_CLIENTS
  where STATUS = 'TIMEOUT'
  and JACKPOT_ID=:VAR_JACKPOT_ID
  into :RES_CLIENTS_TIMEOUT;

  select count(STATUS)
  from JACKPOT_CLIENTS
  where STATUS = 'OUT'
  and JACKPOT_ID=:VAR_JACKPOT_ID
  into :RES_CLIENTS_OUT;

  RES_CAPTION = :VAR_JACKPOT_ID||' jackpot status OK.';
  RES_RESULT = 0;
  SUSPEND;
END;
^

CREATE or ALTER PROCEDURE C_WIN_NUM_HOTCOLD(
  WIN_NUM_COUNT SMALLINT,
  HOT_COLD_COUNT SMALLINT)
RETURNS(
  RES_WIN_NUMBER SMALLINT,
  RES_DESCRIPTION VARCHAR(20) CHARACTER SET WIN1250)
AS
DECLARE VARIABLE TMP_CNT INTEGER;
DECLARE VARIABLE TMP_STRIKE_COUNT INTEGER;
DECLARE VARIABLE TMP_WIN_NUM INTEGER;
BEGIN

 TMP_CNT=0;
 for select
      count(RES_WIN_NUM) as strike_count,
      RES_WIN_NUM
 from C_WIN_NUM_HIST(100)
 group by RES_WIN_NUM
 order by strike_count
 into :TMP_STRIKE_COUNT,
      :RES_WIN_NUMBER
 do begin
    TMP_CNT=TMP_CNT+1;
    if (TMP_CNT <= HOT_COLD_COUNT) then
    begin
         RES_DESCRIPTION = 'HOT_'||:TMP_CNT;
         suspend;
    end

    if (TMP_CNT >= 37-HOT_COLD_COUNT-1) then
    begin
         RES_DESCRIPTION = 'COLD_'||(:TMP_CNT+:HOT_COLD_COUNT-37+2);
         suspend;
    end
 end

END;
^

create or ALTER PROCEDURE C_WIN_NUM_STAT(
  VAR_WIN_NUM_COUNT SMALLINT)
RETURNS(
  RES_RED_PERCENTAGE NUMERIC(18, 4),
  RES_BLACK_PERCENTAGE NUMERIC(18, 4),
  RES_GREEN_PERCENTAGE NUMERIC(18, 4),
  RES_ODD_PERCENTAGE NUMERIC(18, 4),
  RES_EVEN_PERCENTAGE NUMERIC(18, 4),
  RES_ZERO_PERCENTAGE NUMERIC(18, 4))
AS
DECLARE VARIABLE TMP_WIN_NUM SMALLINT;
DECLARE VARIABLE TMP_ALL_COUNT SMALLINT;
DECLARE VARIABLE TMP_RED_COUNT SMALLINT;
DECLARE VARIABLE TMP_BLACK_COUNT SMALLINT;
DECLARE VARIABLE TMP_GREEN_COUNT SMALLINT;
DECLARE VARIABLE TMP_ODD_COUNT SMALLINT;
DECLARE VARIABLE TMP_ZERO_COUNT SMALLINT;
DECLARE VARIABLE TMP_EVEN_COUNT SMALLINT;
BEGIN

  TMP_ALL_COUNT=0;
  TMP_RED_COUNT = 0;
  TMP_BLACK_COUNT = 0;
  TMP_GREEN_COUNT = 0;
  TMP_ODD_COUNT = 0;
  TMP_ZERO_COUNT = 0;
  TMP_EVEN_COUNT = 0;

  for select RES_WIN_NUM
  from C_WIN_NUM_HIST(100)
  into :TMP_WIN_NUM
  do
  begin
       TMP_ALL_COUNT = TMP_ALL_COUNT+1;
       --prestejemo rdece
       if ( 1=TMP_WIN_NUM or
            3=TMP_WIN_NUM or
            5=TMP_WIN_NUM or
            7=TMP_WIN_NUM or
            9=TMP_WIN_NUM or
            12=TMP_WIN_NUM or
            14=TMP_WIN_NUM or
            16=TMP_WIN_NUM or
            18=TMP_WIN_NUM or
            19=TMP_WIN_NUM or
            21=TMP_WIN_NUM or
            23=TMP_WIN_NUM or
            25=TMP_WIN_NUM or
            27=TMP_WIN_NUM or
            30=TMP_WIN_NUM or
            32=TMP_WIN_NUM or
            34=TMP_WIN_NUM or
            36=TMP_WIN_NUM
       ) then
         TMP_RED_COUNT = TMP_RED_COUNT+1;

--prestejemo crne
       if ( 2=TMP_WIN_NUM or
            4=TMP_WIN_NUM or
            6=TMP_WIN_NUM or
            8=TMP_WIN_NUM or
            10=TMP_WIN_NUM or
            11=TMP_WIN_NUM or
            13=TMP_WIN_NUM or
            15=TMP_WIN_NUM or
            17=TMP_WIN_NUM or
            20=TMP_WIN_NUM or
            22=TMP_WIN_NUM or
            24=TMP_WIN_NUM or
            26=TMP_WIN_NUM or
            28=TMP_WIN_NUM or
            29=TMP_WIN_NUM or
            31=TMP_WIN_NUM or
            33=TMP_WIN_NUM or
            35=TMP_WIN_NUM
       ) then
         TMP_BLACK_COUNT = TMP_BLACK_COUNT+1;

--prestejemo zelene
       if ( 0=TMP_WIN_NUM or
            37=TMP_WIN_NUM
       ) then
         TMP_GREEN_COUNT = TMP_GREEN_COUNT+1;

--prestejemo lihe
       if ( 1=mod(TMP_WIN_NUM, 2)
       ) then
         TMP_ODD_COUNT = TMP_ODD_COUNT+1;
--prestejemo even
       if ( 0=mod(TMP_WIN_NUM, 2)
       ) then
         TMP_EVEN_COUNT = TMP_EVEN_COUNT+1;
--prestejemo nicle
       if ( 0=TMP_WIN_NUM or
            37=TMP_WIN_NUM
       ) then
         TMP_ZERO_COUNT = TMP_ZERO_COUNT+1;


  end --end for

  if ( 0=TMP_ALL_COUNT ) then
  begin
    RES_RED_PERCENTAGE = 0;
    RES_BLACK_PERCENTAGE = 0;
    RES_GREEN_PERCENTAGE = 0;
    suspend;
    exit;
  end

  RES_RED_PERCENTAGE = TMP_RED_COUNT/cast(TMP_ALL_COUNT as numeric(18,4))*100;
  RES_BLACK_PERCENTAGE = TMP_BLACK_COUNT/cast(TMP_ALL_COUNT as numeric(18,4))*100;
  RES_GREEN_PERCENTAGE = TMP_GREEN_COUNT/cast(TMP_ALL_COUNT as numeric(18,4))*100;

  RES_ODD_PERCENTAGE = TMP_ODD_COUNT/cast(TMP_ALL_COUNT as numeric(18,4))*100;
  RES_EVEN_PERCENTAGE = TMP_EVEN_COUNT/cast(TMP_ALL_COUNT as numeric(18,4))*100;
  RES_ZERO_PERCENTAGE = TMP_ZERO_COUNT/cast(TMP_ALL_COUNT as numeric(18,4))*100;

  SUSPEND;
END;
^
commit retain ^
CREATE TABLE BUF_LOG_TOTALS_ALL_DAILY2 (
  VAR_CLIENT_IP VARCHAR(15) CHARACTER SET WIN1250 NOT NULL COLLATE WIN1250,
  VAR_DATE T_TDATE NOT NULL,
  RES_BET DECIMAL(18, 2) DEFAULT 0,
  RES_WIN DECIMAL(18, 2) DEFAULT 0,
  RES_IN DECIMAL(18, 2) DEFAULT 0,
  RES_OUT DECIMAL(18, 2) DEFAULT 0,
  RES_BILL_IN DECIMAL(18, 2) DEFAULT 0,
  RES_BILL_OUT DECIMAL(18, 2) DEFAULT 0,
  RES_COIN_IN DECIMAL(18, 2) DEFAULT 0,
  RES_COIN_OUT DECIMAL(18, 2) DEFAULT 0,
  RES_ATTENDANT_IN DECIMAL(18, 2) DEFAULT 0,
  RES_ATTENDANT_OUT DECIMAL(18, 2) DEFAULT 0,
  RES_TICKET_IN DECIMAL(18, 2) DEFAULT 0,
  RES_TICKET_OUT DECIMAL(18, 2) DEFAULT 0,
  RES_MINIGAME_BET DECIMAL(18, 2) DEFAULT 0,
  RES_MINIGAME_WIN DECIMAL(18, 2) DEFAULT 0,
  RES_JACKPOTS_OUT DECIMAL(18, 2) DEFAULT 0)^
  commit retain^
ALTER TABLE BUF_LOG_TOTALS_ALL_DAILY2 ADD PRIMARY KEY (VAR_CLIENT_IP,VAR_DATE)^
commit retain^

CREATE global temporary TABLE MONETARY_GTT (
  MON_ID T_TID NOT NULL,
  CLIENT_IP T_MACHINE_IP NOT NULL,
  MON_OPERATION_TIME T_TTIMESTAMP,
  MON_OPERATION_TYPE T_TTAG NOT NULL,
  MON_CREDIT_VALUE T_CREDIT,
  MON_C_ID T_TID NOT NULL,
  GAME_ID T_TID,
  CONFIRMED T_TBOOLEAN NOT NULL,
  MON_MONEY_VALUE T_MONEY)
  on commit delete rows^
commit retain^
ALTER TABLE MONETARY_GTT ADD CONSTRAINT INTEG_TMP_44 PRIMARY KEY (MON_ID)^
CREATE INDEX IDX_MONETARY_GTT1 ON MONETARY_GTT(CLIENT_IP)^
CREATE DESC INDEX IDX_MONETARY_GTT2 ON MONETARY_GTT(MON_ID,MON_OPERATION_TIME)^
CREATE INDEX IDX_MONETARY_GTT3_BY_CASHD ON MONETARY_GTT(MON_OPERATION_TYPE,CONFIRMED)^
CREATE INDEX IDX_MONETARY_GTT4_BY_CASHD ON MONETARY_GTT(MON_OPERATION_TIME,MON_OPERATION_TYPE,CONFIRMED)^
CREATE UNIQUE INDEX INTEG_GTT_37 ON MONETARY_GTT(MON_ID)^
commit retain^

CREATE global temporary TABLE CREDIT_TRANSFERS_GTT (
  CT_ID T_TID NOT NULL,
  GAME_ID T_TID NOT NULL,
  CLIENT_IP T_MACHINE_IP NOT NULL,
  FROM_IP T_MACHINE_IP NOT NULL,
  TO_IP T_MACHINE_IP NOT NULL,
  CREDIT_VALUE T_CREDIT NOT NULL,
  IS_CACHABLE T_TBOOLEAN,
  TIME_STAMP T_TTIMESTAMP,
  CREDIT_TYPE T_TINTEGER DEFAULT 11 NOT NULL)
  on commit delete rows^
commit retain^
ALTER TABLE CREDIT_TRANSFERS_GTT ADD CONSTRAINT INTEG_TMP_38 PRIMARY KEY (CT_ID)^
CREATE INDEX IDX_CREDIT_TRANSFERS_GTT ON CREDIT_TRANSFERS_GTT(TO_IP,GAME_ID)^
CREATE INDEX IDX_CREDIT_TRANSFERS_GTT1 ON CREDIT_TRANSFERS_GTT(FROM_IP,GAME_ID)^
CREATE INDEX IDX_CREDIT_TRANSFERS_GTT2 ON CREDIT_TRANSFERS_GTT(FROM_IP,GAME_ID)^
CREATE DESC INDEX IDX_CREDIT_TRANSFERS_GTT3 ON CREDIT_TRANSFERS_GTT(GAME_ID,TIME_STAMP)^
CREATE UNIQUE INDEX INTEG_TMP_68 ON CREDIT_TRANSFERS_GTT(CT_ID)^
commit retain^

CREATE or ALTER PROCEDURE LOG_TOTALS_ALL_DAILY2(
  VAR_CLIENT_IP VARCHAR(15) CHARACTER SET WIN1250,
  VAR_COUNT_DAYS INTEGER,
  VAR_DISABLE_CACHE INTEGER)
RETURNS(
  RES_OP_DATE VARCHAR(30) CHARACTER SET WIN1250,
  RES_BET DECIMAL(18, 2),
  RES_WIN DECIMAL(18, 2),
  RES_IN DECIMAL(18, 2),
  RES_OUT DECIMAL(18, 2),
  RES_BET_PROFIT_PERCENT VARCHAR(15) CHARACTER SET WIN1250,
  RES_PAYIN_PROFIT_PERCENT VARCHAR(15) CHARACTER SET WIN1250,
  RES_PAYBACK_PERCENT VARCHAR(15) CHARACTER SET WIN1250,
  RES_PROFIT DECIMAL(18, 2),
  RES_BILL_IN DECIMAL(18, 2),
  RES_BILL_OUT DECIMAL(18, 2),
  RES_COIN_IN DECIMAL(18, 2),
  RES_COIN_OUT DECIMAL(18, 2),
  RES_ATTENDANT_IN DECIMAL(18, 2),
  RES_ATTENDANT_OUT DECIMAL(18, 2),
  RES_TICKET_IN DECIMAL(18, 2),
  RES_TICKET_OUT DECIMAL(18, 2),
  RES_MINIGAME_BET DECIMAL(18, 2),
  RES_MINIGAME_WIN DECIMAL(18, 2),
  RES_MINIGAME_PROFIT DECIMAL(18, 2),
  RES_MINIGAME_PAYBACK_PERCENT VARCHAR(15) CHARACTER SET WIN1250,
  RES_JACKPOTS_OUT DECIMAL(18, 2))
AS
DECLARE VARIABLE TMP_FROM_TIMESTAMP TIMESTAMP;
DECLARE VARIABLE TMP_TO_TIMESTAMP TIMESTAMP;
DECLARE VARIABLE TMP_DAY_INDEX SMALLINT;
DECLARE VARIABLE C_COEFF INTEGER;
DECLARE VARIABLE M_COEFF INTEGER;
DECLARE VARIABLE TMP_BET DECIMAL(18, 2);
DECLARE VARIABLE TMP_WIN DECIMAL(18, 2);
DECLARE VARIABLE TMP_IN DECIMAL(18, 2);
DECLARE VARIABLE TMP_OUT DECIMAL(18, 2);
DECLARE VARIABLE TMP_PROFIT DECIMAL(18, 2);
DECLARE VARIABLE TMP_BILL_IN DECIMAL(18, 2);
DECLARE VARIABLE TMP_BILL_OUT DECIMAL(18, 2);
DECLARE VARIABLE TMP_COIN_IN DECIMAL(18, 2);
DECLARE VARIABLE TMP_COIN_OUT DECIMAL(18, 2);
DECLARE VARIABLE TMP_ATTENDANT_IN DECIMAL(18, 2);
DECLARE VARIABLE TMP_ATTENDANT_OUT DECIMAL(18, 2);
DECLARE VARIABLE TMP_TICKET_IN DECIMAL(18, 2);
DECLARE VARIABLE TMP_TICKET_OUT DECIMAL(18, 2);
DECLARE VARIABLE TMP_MINIGAME_BET DECIMAL(18, 2);
DECLARE VARIABLE TMP_MINIGAME_WIN DECIMAL(18, 2);
DECLARE VARIABLE TMP_MINIGAME_PROFIT DECIMAL(18, 2);
DECLARE VARIABLE TMP_JACKPOTS_OUT DECIMAL(18, 2);
DECLARE VARIABLE TMP_ABORTED DECIMAL(18, 2);
BEGIN

if ( VAR_CLIENT_IP is null or VAR_COUNT_DAYS is null or VAR_COUNT_DAYS < 1 ) then
begin
     RES_OP_DATE= '1.1.2000';
     RES_BET = 0;
     RES_WIN = 0;
     RES_IN = 0;
     RES_OUT = 0;
     RES_BET_PROFIT_PERCENT = 0;
     RES_PAYIN_PROFIT_PERCENT = 0;
     RES_PAYBACK_PERCENT = 0;
     RES_PROFIT = 0;
     RES_BILL_IN = 0;
     RES_BILL_OUT = 0;
     RES_COIN_IN = 0;
     RES_COIN_OUT = 0;
     RES_ATTENDANT_IN = 0;
     RES_ATTENDANT_OUT = 0;
     RES_TICKET_IN = 0;
     RES_TICKET_OUT = 0;
     RES_MINIGAME_BET = 0;
     RES_MINIGAME_WIN = 0;
     RES_MINIGAME_PROFIT = 0;
     RES_MINIGAME_PAYBACK_PERCENT = 0;
     RES_JACKPOTS_OUT = 0;
     suspend;
     exit;
end

TMP_BET=0;
TMP_WIN=0;
TMP_IN=0;
TMP_OUT=0;
TMP_PROFIT=0;
TMP_BILL_IN=0;
TMP_BILL_OUT=0;
TMP_COIN_IN=0;
TMP_COIN_OUT=0;
TMP_ATTENDANT_IN=0;
TMP_ATTENDANT_OUT=0;
TMP_TICKET_IN=0;
TMP_TICKET_OUT=0;
TMP_MINIGAME_BET=0;
TMP_MINIGAME_WIN=0;
TMP_MINIGAME_PROFIT=0;
TMP_JACKPOTS_OUT=0;
TMP_ABORTED=0;

-- vraca vrednosti PAYIN, PAYOUT, BET, WIN, BILL, COIN, ATTENDANT, TICKET,... po dnevih od polnoci do polnoci
-- vrednosti vraca v VALUTI!!

select RES_NUM_VALUE
from GET_PARAM('192.168.0.0', 'BILL_CURRENCY_TO_CREDIT', 11)
into :M_COEFF;
select RES_NUM_VALUE
from GET_PARAM('192.168.0.0', 'BILL_CREDIT_TO_CURRENCY', 11)
into :C_COEFF;
if (M_COEFF is null or (0=M_COEFF)) then
   M_COEFF = 1;
if (C_COEFF is null or (0=C_COEFF)) then
   C_COEFF = 1;

TMP_FROM_TIMESTAMP = current_date - :VAR_COUNT_DAYS;
TMP_TO_TIMESTAMP = ''||extract(year from current_date)||'-'||extract(month from current_date)||'-'||extract(day from current_date)||' 23:59:59';
--to ne dela TMP_TO_TIMESTAMP = current_date + cast(86399 as float)/cast(86400 as float);--23:59:59

TMP_DAY_INDEX=0;
while ( VAR_COUNT_DAYS > TMP_DAY_INDEX ) do
begin

TMP_FROM_TIMESTAMP = current_date - :TMP_DAY_INDEX;
TMP_TO_TIMESTAMP = ''||extract(year from TMP_FROM_TIMESTAMP)||'-'||extract(month from TMP_FROM_TIMESTAMP)||'-'||extract(day from TMP_FROM_TIMESTAMP)||' 23:59:59';
-- to ne dela! TMP_TO_TIMESTAMP = current_date - :TMP_DAY_INDEX + cast(86399 as float)/cast(86400 as float);--23:59:59
RES_OP_DATE = current_date - :TMP_DAY_INDEX;

--damo vse vrednosti na NULL, tako bomo vedeli, ce katera ni bila prebrana iz cache tabele
RES_BET = NULL;
RES_WIN = NULL;
RES_IN = NULL;
RES_OUT = NULL;
RES_BILL_IN = NULL;
RES_BILL_OUT = NULL;
RES_COIN_IN = NULL;
RES_COIN_OUT = NULL;
RES_ATTENDANT_IN = NULL;
RES_ATTENDANT_OUT = NULL;
RES_TICKET_IN = NULL;
RES_TICKET_OUT = NULL;
RES_MINIGAME_BET = NULL;
RES_MINIGAME_WIN = NULL;
RES_JACKPOTS_OUT = NULL;

if ( 0=VAR_DISABLE_CACHE ) then
--preverimo, ali je ta zapis ze v cache-tabeli
select RES_BET,
       RES_WIN,
       RES_IN,
       RES_OUT,
       RES_BILL_IN,
       RES_BILL_OUT,
       RES_COIN_IN,
       RES_COIN_OUT,
       RES_ATTENDANT_IN,
       RES_ATTENDANT_OUT,
       RES_TICKET_IN,
       RES_TICKET_OUT,
       RES_MINIGAME_BET,
       RES_MINIGAME_WIN,
       RES_JACKPOTS_OUT
from BUF_LOG_TOTALS_ALL_DAILY2
where BUF_LOG_TOTALS_ALL_DAILY2.VAR_CLIENT_IP = :VAR_CLIENT_IP and
      BUF_LOG_TOTALS_ALL_DAILY2.VAR_DATE = :RES_OP_DATE
into :RES_BET,
     :RES_WIN,
     :RES_IN,
     :RES_OUT,
     :RES_BILL_IN,
     :RES_BILL_OUT,
     :RES_COIN_IN,
     :RES_COIN_OUT,
     :RES_ATTENDANT_IN,
     :RES_ATTENDANT_OUT,
     :RES_TICKET_IN,
     :RES_TICKET_OUT,
     :RES_MINIGAME_BET,
     :RES_MINIGAME_WIN,
     :RES_JACKPOTS_OUT;

if ( 0=TMP_DAY_INDEX--za danasnji dan vedno delamo query
  or RES_BET is null
  or RES_WIN is null
  or RES_IN is null
  or RES_OUT is null
  or RES_BILL_IN is null
  or RES_BILL_OUT is null
  or RES_COIN_IN is null
  or RES_COIN_OUT is null
  or RES_ATTENDANT_IN is null
  or RES_ATTENDANT_OUT is null
  or RES_TICKET_IN is null
  or RES_TICKET_OUT is null
  or RES_MINIGAME_BET is null
  or RES_MINIGAME_WIN is null
  or RES_JACKPOTS_OUT is null
 ) then
begin --nimamo cache-a za ta dan, moramo narediti query-e

    --najhitreje dela, ce prepumpamo podatke v zacasno tabelo za trenutni dan, potem pa operiramo nad tem dnevom zato,
    --najprej prepumpamo vse recorde ki ustrezaju obmocju izracuna v CREDIT_TRANSFERS_GTT, nato naredimo query-je nad TMP tabelo
    --tako dela hitreje, ker pregledujemo manjsi set podatkov
    delete from CREDIT_TRANSFERS_GTT where CT_ID>0;
    INSERT INTO
        CREDIT_TRANSFERS_GTT(CT_ID,
                   GAME_ID,
                   CLIENT_IP,
                   FROM_IP,
                   TO_IP,
                   CREDIT_VALUE,
                   IS_CACHABLE,
                   TIME_STAMP,
                   CREDIT_TYPE)
    SELECT
        CREDIT_TRANSFERS.CT_ID,
        CREDIT_TRANSFERS.GAME_ID,
        CREDIT_TRANSFERS.CLIENT_IP,
        CREDIT_TRANSFERS.FROM_IP,
        CREDIT_TRANSFERS.TO_IP,
        CREDIT_TRANSFERS.CREDIT_VALUE,
        CREDIT_TRANSFERS.IS_CACHABLE,
        CREDIT_TRANSFERS.TIME_STAMP,
        CREDIT_TRANSFERS.CREDIT_TYPE
    FROM
        CREDIT_TRANSFERS
    WHERE CREDIT_TRANSFERS.TIME_STAMP >= :TMP_FROM_TIMESTAMP;

    delete from MONETARY_GTT where mon_id>0;
    INSERT INTO
        MONETARY_GTT(MON_ID,
                   CLIENT_IP,
                   MON_OPERATION_TIME,
                   MON_OPERATION_TYPE,
                   MON_CREDIT_VALUE,
                   MON_C_ID,
                   GAME_ID,
                   CONFIRMED,
                   MON_MONEY_VALUE)
    SELECT
        MONETARY.MON_ID,
        MONETARY.CLIENT_IP,
        MONETARY.MON_OPERATION_TIME,
        MONETARY.MON_OPERATION_TYPE,
        MONETARY.MON_CREDIT_VALUE,
        MONETARY.MON_C_ID,
        MONETARY.GAME_ID,
        MONETARY.CONFIRMED,
        MONETARY.MON_MONEY_VALUE
    FROM
        MONETARY
    WHERE
         MONETARY.MON_OPERATION_TIME >= :TMP_FROM_TIMESTAMP;
     
    --izracunamo vrednosti
    --TOTAL BET,WIN
    select (sum(CREDIT_TRANSFERS_GTT.CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from CREDIT_TRANSFERS_GTT
    where CREDIT_TRANSFERS_GTT.TO_IP like :VAR_CLIENT_IP and
          CREDIT_TRANSFERS_GTT.FROM_IP = '192.168.0.0' and
          (CREDIT_TRANSFERS_GTT.CLIENT_IP = 'Roulette' or
          CREDIT_TRANSFERS_GTT.CLIENT_IP = 'Jackpot Win' or
          CREDIT_TRANSFERS_GTT.CLIENT_IP = 'Bonus Spin Win') and
          CREDIT_TRANSFERS_GTT.TIME_STAMP >= :TMP_FROM_TIMESTAMP and CREDIT_TRANSFERS_GTT.TIME_STAMP <= :TMP_TO_TIMESTAMP
    into :RES_WIN;
    if ( RES_WIN is null ) then
       RES_WIN = 0;
    select (sum(CREDIT_TRANSFERS_GTT.CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from CREDIT_TRANSFERS_GTT
    where CREDIT_TRANSFERS_GTT.TO_IP = '192.168.0.0' and
          CREDIT_TRANSFERS_GTT.FROM_IP like :VAR_CLIENT_IP and
          CREDIT_TRANSFERS_GTT.CLIENT_IP = 'Roulette' and
          CREDIT_TRANSFERS_GTT.TIME_STAMP >= :TMP_FROM_TIMESTAMP and CREDIT_TRANSFERS_GTT.TIME_STAMP <= :TMP_TO_TIMESTAMP
    into :RES_BET;
    if ( RES_BET is null ) then
       RES_BET = 0;

    --TOTAL IN/OUT
    select (sum(MONETARY_GTT.MON_CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from MONETARY_GTT
    where MONETARY_GTT.CLIENT_IP like :VAR_CLIENT_IP and
          MONETARY_GTT.MON_OPERATION_TYPE = 'IN' and
          MONETARY_GTT.CONFIRMED > 0 and
          MONETARY_GTT.MON_OPERATION_TIME >= :TMP_FROM_TIMESTAMP and MONETARY_GTT.MON_OPERATION_TIME <= :TMP_TO_TIMESTAMP
    into :RES_IN;
    if ( RES_IN is null ) then
       RES_IN = 0;

    select (sum(MONETARY_GTT.MON_CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from MONETARY_GTT
    where MONETARY_GTT.CLIENT_IP like :VAR_CLIENT_IP and
          MONETARY_GTT.MON_OPERATION_TYPE = 'OUT' and
          MONETARY_GTT.CONFIRMED > 0 and
          MONETARY_GTT.MON_OPERATION_TIME >= :TMP_FROM_TIMESTAMP and MONETARY_GTT.MON_OPERATION_TIME <= :TMP_TO_TIMESTAMP
    into :RES_OUT;
    if ( RES_OUT is null ) then
       RES_OUT = 0;
            --tukaj moramo odsteti se aborted credits,NOTE: ko bo delalo potrjevanje transakcij za izplacila, tole potrebno umakniti
            select (sum(CREDIT_TRANSFERS_GTT.CREDIT_VALUE) * :M_COEFF) / cast(
            :C_COEFF as numeric (18, 4))
            from CREDIT_TRANSFERS_GTT
            where CREDIT_TRANSFERS_GTT.TO_IP like :VAR_CLIENT_IP and
                  CREDIT_TRANSFERS_GTT.FROM_IP = '192.168.0.0' and
                  CREDIT_TRANSFERS_GTT.CLIENT_IP = 'Payout Abort' and
                  CREDIT_TRANSFERS_GTT.TIME_STAMP >= :TMP_FROM_TIMESTAMP and CREDIT_TRANSFERS_GTT.TIME_STAMP <= :TMP_TO_TIMESTAMP
            into :TMP_ABORTED;
            if ( TMP_ABORTED is null ) then
               TMP_ABORTED = 0;
            RES_OUT = RES_OUT-TMP_ABORTED;--odstejemo od out, ker je aborted 2x vpisan v MONETARY_GTT

    --ATTENDANT_ IN/OUT
    select (sum(MONETARY_GTT.MON_CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from MONETARY_GTT
    where MONETARY_GTT.CLIENT_IP like :VAR_CLIENT_IP and
          MONETARY_GTT.MON_OPERATION_TYPE = 'IN' and
          MONETARY_GTT.CONFIRMED > 0 and
          MONETARY_GTT.MON_C_ID = 1002 and
          MONETARY_GTT.MON_OPERATION_TIME >= :TMP_FROM_TIMESTAMP and MONETARY_GTT.MON_OPERATION_TIME <= :TMP_TO_TIMESTAMP
    into :RES_ATTENDANT_IN;
    if ( RES_ATTENDANT_IN is null ) then
       RES_ATTENDANT_IN = 0;
    select (sum(MONETARY_GTT.MON_CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from MONETARY_GTT
    where MONETARY_GTT.CLIENT_IP like :VAR_CLIENT_IP and
          MONETARY_GTT.MON_OPERATION_TYPE = 'OUT' and
          MONETARY_GTT.CONFIRMED > 0 and
          MONETARY_GTT.MON_C_ID = 1002 and
          MONETARY_GTT.MON_OPERATION_TIME >= :TMP_FROM_TIMESTAMP and MONETARY_GTT.MON_OPERATION_TIME <= :TMP_TO_TIMESTAMP
    into :RES_ATTENDANT_OUT;
    if ( RES_ATTENDANT_OUT is null ) then
       RES_ATTENDANT_OUT = 0;
    --COIN IN/OUT
    select (sum(MONETARY_GTT.MON_CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from MONETARY_GTT
    where MONETARY_GTT.CLIENT_IP like :VAR_CLIENT_IP and
          MONETARY_GTT.MON_OPERATION_TYPE = 'IN' and
          MONETARY_GTT.CONFIRMED > 0 and
          MONETARY_GTT.MON_C_ID >= 3000 and
          MONETARY_GTT.MON_C_ID < 4000 --kovanci
          and
          MONETARY_GTT.MON_OPERATION_TIME >= :TMP_FROM_TIMESTAMP and MONETARY_GTT.MON_OPERATION_TIME <= :TMP_TO_TIMESTAMP
    into :RES_COIN_IN;
    if ( RES_COIN_IN is null ) then
       RES_COIN_IN = 0;
    select (sum(MONETARY_GTT.MON_CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from MONETARY_GTT
    where MONETARY_GTT.CLIENT_IP like :VAR_CLIENT_IP and
          MONETARY_GTT.MON_OPERATION_TYPE = 'OUT' and
          MONETARY_GTT.CONFIRMED > 0 and
          MONETARY_GTT.MON_C_ID >= 3000 and
          MONETARY_GTT.MON_C_ID < 4000 --kovanci
          and
          MONETARY_GTT.MON_OPERATION_TIME >= :TMP_FROM_TIMESTAMP and MONETARY_GTT.MON_OPERATION_TIME <= :TMP_TO_TIMESTAMP
    into :RES_COIN_OUT;
    if ( RES_COIN_OUT is null ) then
       RES_COIN_OUT = 0;
    --BILL IN/OUT
    select (sum(MONETARY_GTT.MON_CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from MONETARY_GTT
    where MONETARY_GTT.CLIENT_IP like :VAR_CLIENT_IP and
          MONETARY_GTT.MON_OPERATION_TYPE = 'IN' and
          MONETARY_GTT.CONFIRMED > 0 and
          MONETARY_GTT.MON_C_ID >= 2000 and
          MONETARY_GTT.MON_C_ID < 3000 --billacceptor
          and
          MONETARY_GTT.MON_OPERATION_TIME >= :TMP_FROM_TIMESTAMP and MONETARY_GTT.MON_OPERATION_TIME <= :TMP_TO_TIMESTAMP
    into :RES_BILL_IN;
    if ( RES_BILL_IN is null ) then
       RES_BILL_IN = 0;
    select (sum(MONETARY_GTT.MON_CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from MONETARY_GTT
    where MONETARY_GTT.CLIENT_IP like :VAR_CLIENT_IP and
          MONETARY_GTT.MON_OPERATION_TYPE = 'OUT' and
          MONETARY_GTT.CONFIRMED > 0 and
          MONETARY_GTT.MON_C_ID >= 2000 and
          MONETARY_GTT.MON_C_ID < 3000 --billacceptor
          and
          MONETARY_GTT.MON_OPERATION_TIME >= :TMP_FROM_TIMESTAMP and MONETARY_GTT.MON_OPERATION_TIME <= :TMP_TO_TIMESTAMP
    into :RES_BILL_OUT;
    if ( RES_BILL_OUT is null ) then
       RES_BILL_OUT = 0;
    --TICKET IN/OUT
    select (sum(MONETARY_GTT.MON_CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from MONETARY_GTT
    where MONETARY_GTT.CLIENT_IP like :VAR_CLIENT_IP and
          MONETARY_GTT.MON_OPERATION_TYPE = 'IN' and
          MONETARY_GTT.CONFIRMED > 0 and
          MONETARY_GTT.MON_C_ID >= 50000 --tickets
          and
          MONETARY_GTT.MON_OPERATION_TIME >= :TMP_FROM_TIMESTAMP and MONETARY_GTT.MON_OPERATION_TIME <= :TMP_TO_TIMESTAMP
    into :RES_TICKET_IN;
    if ( RES_TICKET_IN is null ) then
       RES_TICKET_IN = 0;
    select (sum(MONETARY_GTT.MON_CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from MONETARY_GTT
    where MONETARY_GTT.CLIENT_IP like :VAR_CLIENT_IP and
          MONETARY_GTT.MON_OPERATION_TYPE = 'OUT' and
          MONETARY_GTT.CONFIRMED > 0 and
          MONETARY_GTT.MON_C_ID >= 50000 --tickets
          and
          MONETARY_GTT.MON_OPERATION_TIME >= :TMP_FROM_TIMESTAMP and MONETARY_GTT.MON_OPERATION_TIME <= :TMP_TO_TIMESTAMP
    into :RES_TICKET_OUT;
    if ( RES_TICKET_OUT is null ) then
       RES_TICKET_OUT = 0;
    --minigame
    select (sum(CREDIT_TRANSFERS_GTT.CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from CREDIT_TRANSFERS_GTT
    where CREDIT_TRANSFERS_GTT.TO_IP = '192.168.0.0' and
          CREDIT_TRANSFERS_GTT.FROM_IP like :VAR_CLIENT_IP and
          (CREDIT_TRANSFERS_GTT.CLIENT_IP = 'Minigame Fichas' or
          CREDIT_TRANSFERS_GTT.CLIENT_IP = 'Minigame Nada' or
          CREDIT_TRANSFERS_GTT.CLIENT_IP = 'Minigame Premio') and
          CREDIT_TRANSFERS_GTT.TIME_STAMP >= :TMP_FROM_TIMESTAMP and CREDIT_TRANSFERS_GTT.TIME_STAMP <= :TMP_TO_TIMESTAMP
    into :RES_MINIGAME_BET;
    if ( RES_MINIGAME_BET is null ) then
       RES_MINIGAME_BET = 0;
    select (sum(CREDIT_TRANSFERS_GTT.CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from CREDIT_TRANSFERS_GTT
    where CREDIT_TRANSFERS_GTT.TO_IP like :VAR_CLIENT_IP and
          CREDIT_TRANSFERS_GTT.FROM_IP = '192.168.0.0' and
          (CREDIT_TRANSFERS_GTT.CLIENT_IP = 'Minigame Fichas' or
          CREDIT_TRANSFERS_GTT.CLIENT_IP = 'Minigame Nada' or
          CREDIT_TRANSFERS_GTT.CLIENT_IP = 'Minigame Premio') and
          CREDIT_TRANSFERS_GTT.TIME_STAMP >= :TMP_FROM_TIMESTAMP and CREDIT_TRANSFERS_GTT.TIME_STAMP <= :TMP_TO_TIMESTAMP
    into :RES_MINIGAME_WIN;
    if ( RES_MINIGAME_WIN is null ) then
       RES_MINIGAME_WIN = 0;
    --jackpots
    select (sum(CREDIT_TRANSFERS_GTT.CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from CREDIT_TRANSFERS_GTT
    where CREDIT_TRANSFERS_GTT.TO_IP like :VAR_CLIENT_IP and
          CREDIT_TRANSFERS_GTT.FROM_IP = '192.168.0.0' and
          CREDIT_TRANSFERS_GTT.CLIENT_IP = 'Jackpot Win' and
          CREDIT_TRANSFERS_GTT.TIME_STAMP >= :TMP_FROM_TIMESTAMP and CREDIT_TRANSFERS_GTT.TIME_STAMP <= :TMP_TO_TIMESTAMP
    into :RES_JACKPOTS_OUT;
    if ( RES_JACKPOTS_OUT is null ) then
       RES_JACKPOTS_OUT = 0;

    --vnesemo v cache
    delete from BUF_LOG_TOTALS_ALL_DAILY2
    where BUF_LOG_TOTALS_ALL_DAILY2.VAR_DATE = :RES_OP_DATE
    and   BUF_LOG_TOTALS_ALL_DAILY2.VAR_CLIENT_IP = :VAR_CLIENT_IP;

    if ( TMP_DAY_INDEX>0 ) then --danasnjega dneva ne vnasamo, ker bo jutri tezava, se ne bodo sestele vrednosti od sedaj dalje za danasnji dan
    insert into BUF_LOG_TOTALS_ALL_DAILY2(
        VAR_CLIENT_IP,
        VAR_DATE,
        RES_BET,
        RES_WIN,
        RES_IN,
        RES_OUT,
        RES_BILL_IN,
        RES_BILL_OUT,
        RES_COIN_IN,
        RES_COIN_OUT,
        RES_ATTENDANT_IN,
        RES_ATTENDANT_OUT,
        RES_TICKET_IN,
        RES_TICKET_OUT,
        RES_MINIGAME_BET,
        RES_MINIGAME_WIN,
        RES_JACKPOTS_OUT
    )values(
        :VAR_CLIENT_IP,
        :RES_OP_DATE,
        :RES_BET,
        :RES_WIN,
        :RES_IN,
        :RES_OUT,
        :RES_BILL_IN,
        :RES_BILL_OUT,
        :RES_COIN_IN,
        :RES_COIN_OUT,
        :RES_ATTENDANT_IN,
        :RES_ATTENDANT_OUT,
        :RES_TICKET_IN,
        :RES_TICKET_OUT,
        :RES_MINIGAME_BET,
        :RES_MINIGAME_WIN,
        :RES_JACKPOTS_OUT
    );

end--ce ni bilo v cache-u, smo delali query-e

--poracunamo se vrednosti TMP_ in PERCENT-e.., to je skupni del, ne glede na to ali smo query-ali ali brali iz cache-a
    RES_PROFIT = RES_IN-RES_OUT;
    RES_MINIGAME_PROFIT=RES_MINIGAME_BET-RES_MINIGAME_WIN;

    TMP_WIN=TMP_WIN+RES_WIN;
    TMP_BET=TMP_BET+RES_BET;
    TMP_IN=TMP_IN+RES_IN;
    TMP_OUT=TMP_OUT+RES_OUT;
    TMP_PROFIT=TMP_PROFIT+RES_PROFIT;
    TMP_ATTENDANT_IN=TMP_ATTENDANT_IN+RES_ATTENDANT_IN;
    TMP_ATTENDANT_OUT=TMP_ATTENDANT_OUT+RES_ATTENDANT_OUT;
    TMP_COIN_IN=TMP_COIN_IN+RES_COIN_IN;
    TMP_COIN_OUT=TMP_COIN_OUT+RES_COIN_OUT;
    TMP_BILL_IN=TMP_BILL_IN+RES_BILL_IN;
    TMP_BILL_OUT=TMP_BILL_OUT+RES_BILL_OUT;
    TMP_TICKET_IN=TMP_TICKET_IN+RES_TICKET_IN;
    TMP_TICKET_OUT=TMP_TICKET_OUT+RES_TICKET_OUT;
    TMP_MINIGAME_BET=TMP_MINIGAME_BET+RES_MINIGAME_BET;
    TMP_MINIGAME_WIN=TMP_MINIGAME_WIN+RES_MINIGAME_WIN;
    TMP_MINIGAME_PROFIT=TMP_MINIGAME_PROFIT+RES_MINIGAME_PROFIT;
    TMP_JACKPOTS_OUT=TMP_JACKPOTS_OUT+RES_JACKPOTS_OUT;

    if ( RES_BET is not null and RES_BET <> 0 ) then
      RES_BET_PROFIT_PERCENT = cast(cast((RES_PROFIT)*100/RES_BET as numeric(13,2))as varchar(13)) || ' %';
    else
      RES_BET_PROFIT_PERCENT ='0,00 %';

    if ( RES_IN is not null and RES_IN <> 0 ) then
      RES_PAYIN_PROFIT_PERCENT = cast(cast((RES_PROFIT)*100/RES_IN as numeric(13,2))as varchar(13)) || ' %';
    else
      RES_PAYIN_PROFIT_PERCENT ='0,00 %';

    if ( RES_IN is not null and RES_IN <> 0 ) then
      RES_PAYBACK_PERCENT = cast(cast(RES_OUT*100/RES_IN as numeric(13,2))as varchar(13)) || ' %';
    else
      RES_PAYBACK_PERCENT ='100,00 %';

    if ( RES_MINIGAME_BET is not null and RES_MINIGAME_BET <> 0 ) then
      RES_MINIGAME_PAYBACK_PERCENT = cast(cast(RES_MINIGAME_WIN*100/RES_MINIGAME_BET as numeric(13,2))as varchar(13)) || ' %';
    else
      RES_MINIGAME_PAYBACK_PERCENT ='100,00 %';


TMP_DAY_INDEX = TMP_DAY_INDEX+1;
suspend;

end--while days

  --naredimo se sestevek vseh dni
  RES_OP_DATE='DAYS TOTAL';
  RES_BET=TMP_BET;
  RES_WIN=TMP_WIN;
  RES_IN=TMP_IN;
  RES_OUT=TMP_OUT;
  RES_PROFIT=RES_IN-RES_OUT;
   if ( RES_BET is not null and RES_BET <> 0 ) then
      RES_BET_PROFIT_PERCENT = cast(cast((RES_PROFIT)*100/RES_BET as numeric(13,2))as varchar(13)) || ' %';
   else
      RES_BET_PROFIT_PERCENT ='0,00 %';

   if ( RES_IN is not null and RES_IN <> 0 ) then
      RES_PAYIN_PROFIT_PERCENT = cast(cast((RES_PROFIT)*100/RES_IN as numeric(13,2))as varchar(13)) || ' %';
   else
      RES_PAYIN_PROFIT_PERCENT ='0,00 %';

   if ( RES_IN is not null and RES_IN <> 0 ) then
      RES_PAYBACK_PERCENT = cast(cast(RES_OUT*100/RES_IN as numeric(13,2))as varchar(13)) || ' %';
   else
      RES_PAYBACK_PERCENT ='100,00 %';

  RES_BILL_IN=TMP_BILL_IN;
  RES_BILL_OUT=TMP_BILL_OUT;
  RES_COIN_IN=TMP_COIN_IN;
  RES_COIN_OUT=TMP_COIN_OUT;
  RES_ATTENDANT_IN=TMP_ATTENDANT_IN;
  RES_ATTENDANT_OUT=TMP_ATTENDANT_OUT;
  RES_TICKET_IN=TMP_TICKET_IN;
  RES_TICKET_OUT=TMP_TICKET_OUT;
  RES_MINIGAME_BET=TMP_MINIGAME_BET;
  RES_MINIGAME_WIN=TMP_MINIGAME_WIN;
  RES_MINIGAME_PROFIT=TMP_MINIGAME_PROFIT;
   if ( RES_MINIGAME_BET is not null and RES_MINIGAME_BET <> 0 ) then
      RES_MINIGAME_PAYBACK_PERCENT = cast(cast(RES_MINIGAME_WIN*100/RES_MINIGAME_BET as numeric(13,2))as varchar(13)) || ' %';
   else
      RES_MINIGAME_PAYBACK_PERCENT ='100,00 %';

  RES_JACKPOTS_OUT=TMP_JACKPOTS_OUT;

suspend;
END;
^

CREATE or ALTER PROCEDURE LOG_PERIODIC_ALL(
  VAR_CLIENT_IP VARCHAR(15) CHARACTER SET WIN1250,
  VAR_FROM TIMESTAMP,
  VAR_TO TIMESTAMP)
RETURNS(
  RES_BET DECIMAL(18, 2),
  RES_WIN DECIMAL(18, 2),
  RES_IN DECIMAL(18, 2),
  RES_OUT DECIMAL(18, 2),
  RES_BET_PROFIT_PERCENT VARCHAR(15) CHARACTER SET WIN1250,
  RES_PAYIN_PROFIT_PERCENT VARCHAR(15) CHARACTER SET WIN1250,
  RES_PAYBACK_PERCENT VARCHAR(15) CHARACTER SET WIN1250,
  RES_PROFIT DECIMAL(18, 2),
  RES_BILL_IN DECIMAL(18, 2),
  RES_BILL_OUT DECIMAL(18, 2),
  RES_COIN_IN DECIMAL(18, 2),
  RES_COIN_OUT DECIMAL(18, 2),
  RES_ATTENDANT_IN DECIMAL(18, 2),
  RES_ATTENDANT_OUT DECIMAL(18, 2),
  RES_TICKET_IN DECIMAL(18, 2),
  RES_TICKET_OUT DECIMAL(18, 2),
  RES_MINIGAME_BET DECIMAL(18, 2),
  RES_MINIGAME_WIN DECIMAL(18, 2),
  RES_MINIGAME_PROFIT DECIMAL(18, 2),
  RES_MINIGAME_PAYBACK_PERCENT VARCHAR(15) CHARACTER SET WIN1250,
  RES_JACKPOTS_OUT DECIMAL(18, 2))
AS
DECLARE VARIABLE C_COEFF INTEGER;
DECLARE VARIABLE M_COEFF INTEGER;
DECLARE VARIABLE TMP_ABORTED DECIMAL(18, 2);
DECLARE VARIABLE TMP_BET DECIMAL(18, 2);
DECLARE VARIABLE TMP_WIN DECIMAL(18, 2);
DECLARE VARIABLE TMP_IN DECIMAL(18, 2);
DECLARE VARIABLE TMP_OUT DECIMAL(18, 2);
DECLARE VARIABLE TMP_PROFIT DECIMAL(18, 2);
DECLARE VARIABLE TMP_BILL_IN DECIMAL(18, 2);
DECLARE VARIABLE TMP_BILL_OUT DECIMAL(18, 2);
DECLARE VARIABLE TMP_COIN_IN DECIMAL(18, 2);
DECLARE VARIABLE TMP_COIN_OUT DECIMAL(18, 2);
DECLARE VARIABLE TMP_ATTENDANT_IN DECIMAL(18, 2);
DECLARE VARIABLE TMP_ATTENDANT_OUT DECIMAL(18, 2);
DECLARE VARIABLE TMP_TICKET_IN DECIMAL(18, 2);
DECLARE VARIABLE TMP_TICKET_OUT DECIMAL(18, 2);
DECLARE VARIABLE TMP_MINIGAME_BET DECIMAL(18, 2);
DECLARE VARIABLE TMP_MINIGAME_WIN DECIMAL(18, 2);
DECLARE VARIABLE TMP_MINIGAME_PROFIT DECIMAL(18, 2);
DECLARE VARIABLE TMP_JACKPOTS_OUT DECIMAL(18, 2);
BEGIN
if ( VAR_CLIENT_IP is null or VAR_FROM is null or VAR_TO is null )
 then
begin
     RES_BET = 0;
     RES_WIN = 0;
     RES_IN = 0;
     RES_OUT = 0;
     RES_BET_PROFIT_PERCENT = 0;
     RES_PAYIN_PROFIT_PERCENT = 0;
     RES_PAYBACK_PERCENT = 0;
     RES_PROFIT = 0;
     RES_BILL_IN = 0;
     RES_BILL_OUT = 0;
     RES_COIN_IN = 0;
     RES_COIN_OUT = 0;
     RES_ATTENDANT_IN = 0;
     RES_ATTENDANT_OUT = 0;
     RES_TICKET_IN = 0;
     RES_TICKET_OUT = 0;
     RES_MINIGAME_BET = 0;
     RES_MINIGAME_WIN = 0;
     RES_MINIGAME_PROFIT = 0;
     RES_MINIGAME_PAYBACK_PERCENT = 0;
     RES_JACKPOTS_OUT = 0;
     suspend;
     exit;
end

TMP_ABORTED=0;

--vraca vrednosti PAYIN, PAYOUT, BET, WIN, BILL, COIN, ATTENDANT, TICKET,... po dnevih od polnoci do polnoci
--vrednosti vraca v VALUTI!!

select RES_NUM_VALUE
from GET_PARAM('192.168.0.0', 'BILL_CURRENCY_TO_CREDIT', 11)
into :M_COEFF;
select RES_NUM_VALUE
from GET_PARAM('192.168.0.0', 'BILL_CREDIT_TO_CURRENCY', 11)
into :C_COEFF;
if (M_COEFF is null or (0=M_COEFF)) then
   M_COEFF = 1;
if (C_COEFF is null or (0=C_COEFF)) then
   C_COEFF = 1;

    --TOTAL BET,WIN
    select (sum(CREDIT_TRANSFERS.CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from CREDIT_TRANSFERS
    where CREDIT_TRANSFERS.TO_IP like :VAR_CLIENT_IP and
          CREDIT_TRANSFERS.FROM_IP = '192.168.0.0' and
          (CREDIT_TRANSFERS.CLIENT_IP = 'Roulette' or
          CREDIT_TRANSFERS.CLIENT_IP = 'Jackpot Win' or
          CREDIT_TRANSFERS.CLIENT_IP = 'Bonus Spin Win') and
          CREDIT_TRANSFERS.TIME_STAMP > :VAR_FROM and
          CREDIT_TRANSFERS.TIME_STAMP < :VAR_TO
    into :RES_WIN;
    if ( RES_WIN is null ) then
       RES_WIN = 0;
    select (sum(CREDIT_TRANSFERS.CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from CREDIT_TRANSFERS
    where CREDIT_TRANSFERS.TO_IP = '192.168.0.0' and
          CREDIT_TRANSFERS.FROM_IP like :VAR_CLIENT_IP and
          CREDIT_TRANSFERS.CLIENT_IP = 'Roulette' and
          CREDIT_TRANSFERS.TIME_STAMP > :VAR_FROM and
          CREDIT_TRANSFERS.TIME_STAMP < :VAR_TO
    into :RES_BET;
    if ( RES_BET is null ) then
       RES_BET = 0;

    --TOTAL IN/OUT
    select (sum(MONETARY.MON_CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from MONETARY
    where MONETARY.CLIENT_IP like :VAR_CLIENT_IP and
          MONETARY.MON_OPERATION_TYPE = 'IN' and
          MONETARY.CONFIRMED > 0 and
          MONETARY.MON_OPERATION_TIME > :VAR_FROM and
          MONETARY.MON_OPERATION_TIME < :VAR_TO
    into :RES_IN;
    if ( RES_IN is null ) then
       RES_IN = 0;

    select (sum(MONETARY.MON_CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from MONETARY
    where MONETARY.CLIENT_IP like :VAR_CLIENT_IP and
          MONETARY.MON_OPERATION_TYPE = 'OUT' and
          MONETARY.CONFIRMED > 0 and
          MONETARY.MON_OPERATION_TIME > :VAR_FROM and
          MONETARY.MON_OPERATION_TIME < :VAR_TO
    into :RES_OUT;
    if ( RES_OUT is null ) then
       RES_OUT = 0;
            --tukaj moramo odsteti se aborted credits,NOTE: ko bo delalo potrjevanje transakcij za izplacila, tole potrebno umakniti
            select (sum(CREDIT_TRANSFERS.CREDIT_VALUE) * :M_COEFF) / cast(
            :C_COEFF as numeric (18, 4))
            from CREDIT_TRANSFERS
            where CREDIT_TRANSFERS.TO_IP like :VAR_CLIENT_IP and
                  CREDIT_TRANSFERS.FROM_IP = '192.168.0.0' and
                  CREDIT_TRANSFERS.CLIENT_IP = 'Payout Abort' and
                  CREDIT_TRANSFERS.TIME_STAMP > :VAR_FROM and
                  CREDIT_TRANSFERS.TIME_STAMP < :VAR_TO
            into :TMP_ABORTED;
            if ( TMP_ABORTED is null ) then
               TMP_ABORTED = 0;
            RES_OUT = RES_OUT-TMP_ABORTED;--odstejemo od out, ker je aborted 2x vpisan v monetary

    --ATTENDANT_ IN/OUT
    select (sum(MONETARY.MON_CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from MONETARY
    where MONETARY.CLIENT_IP like :VAR_CLIENT_IP and
          MONETARY.MON_OPERATION_TYPE = 'IN' and
          MONETARY.CONFIRMED > 0 and
          MONETARY.MON_C_ID = 1002 and
          MONETARY.MON_OPERATION_TIME > :VAR_FROM and
          MONETARY.MON_OPERATION_TIME < :VAR_TO
    into :RES_ATTENDANT_IN;
    if ( RES_ATTENDANT_IN is null ) then
       RES_ATTENDANT_IN = 0;
    select (sum(MONETARY.MON_CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from MONETARY
    where MONETARY.CLIENT_IP like :VAR_CLIENT_IP and
          MONETARY.MON_OPERATION_TYPE = 'OUT' and
          MONETARY.CONFIRMED > 0 and
          MONETARY.MON_C_ID = 1002 and
          MONETARY.MON_OPERATION_TIME > :VAR_FROM and
          MONETARY.MON_OPERATION_TIME < :VAR_TO
    into :RES_ATTENDANT_OUT;
    if ( RES_ATTENDANT_OUT is null ) then
       RES_ATTENDANT_OUT = 0;
    --COIN IN/OUT
    select (sum(MONETARY.MON_CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from MONETARY
    where MONETARY.CLIENT_IP like :VAR_CLIENT_IP and
          MONETARY.MON_OPERATION_TYPE = 'IN' and
          MONETARY.CONFIRMED > 0 and
          MONETARY.MON_C_ID >= 3000 and
          MONETARY.MON_C_ID < 4000 --kovanci
          and
          MONETARY.MON_OPERATION_TIME > :VAR_FROM and
          MONETARY.MON_OPERATION_TIME < :VAR_TO
    into :RES_COIN_IN;
    if ( RES_COIN_IN is null ) then
       RES_COIN_IN = 0;
    select (sum(MONETARY.MON_CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from MONETARY
    where MONETARY.CLIENT_IP like :VAR_CLIENT_IP and
          MONETARY.MON_OPERATION_TYPE = 'OUT' and
          MONETARY.CONFIRMED > 0 and
          MONETARY.MON_C_ID >= 3000 and
          MONETARY.MON_C_ID < 4000 --kovanci
          and
          MONETARY.MON_OPERATION_TIME > :VAR_FROM and
          MONETARY.MON_OPERATION_TIME < :VAR_TO
    into :RES_COIN_OUT;
    if ( RES_COIN_OUT is null ) then
       RES_COIN_OUT = 0;
    --BILL IN/OUT
    select (sum(MONETARY.MON_CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from MONETARY
    where MONETARY.CLIENT_IP like :VAR_CLIENT_IP and
          MONETARY.MON_OPERATION_TYPE = 'IN' and
          MONETARY.CONFIRMED > 0 and
          MONETARY.MON_C_ID >= 2000 and
          MONETARY.MON_C_ID < 3000 --billacceptor
          and
          MONETARY.MON_OPERATION_TIME > :VAR_FROM and
          MONETARY.MON_OPERATION_TIME < :VAR_TO
    into :RES_BILL_IN;
    if ( RES_BILL_IN is null ) then
       RES_BILL_IN = 0;
    select (sum(MONETARY.MON_CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from MONETARY
    where MONETARY.CLIENT_IP like :VAR_CLIENT_IP and
          MONETARY.MON_OPERATION_TYPE = 'OUT' and
          MONETARY.CONFIRMED > 0 and
          MONETARY.MON_C_ID >= 2000 and
          MONETARY.MON_C_ID < 3000 --billacceptor
          and
          MONETARY.MON_OPERATION_TIME > :VAR_FROM and
          MONETARY.MON_OPERATION_TIME < :VAR_TO
    into :RES_BILL_OUT;
    if ( RES_BILL_OUT is null ) then
       RES_BILL_OUT = 0;
    --TICKET IN/OUT
    select (sum(MONETARY.MON_CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from MONETARY
    where MONETARY.CLIENT_IP like :VAR_CLIENT_IP and
          MONETARY.MON_OPERATION_TYPE = 'IN' and
          MONETARY.CONFIRMED > 0 and
          MONETARY.MON_C_ID >= 50000 --tickets
          and
          MONETARY.MON_OPERATION_TIME > :VAR_FROM and
          MONETARY.MON_OPERATION_TIME < :VAR_TO
    into :RES_TICKET_IN;
    if ( RES_TICKET_IN is null ) then
       RES_TICKET_IN = 0;
    select (sum(MONETARY.MON_CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from MONETARY
    where MONETARY.CLIENT_IP like :VAR_CLIENT_IP and
          MONETARY.MON_OPERATION_TYPE = 'OUT' and
          MONETARY.CONFIRMED > 0 and
          MONETARY.MON_C_ID >= 50000 --tickets
          and
          MONETARY.MON_OPERATION_TIME > :VAR_FROM and
          MONETARY.MON_OPERATION_TIME < :VAR_TO
    into :RES_TICKET_OUT;
    if ( RES_TICKET_OUT is null ) then
       RES_TICKET_OUT = 0;
    --minigame
    select (sum(CREDIT_TRANSFERS.CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from CREDIT_TRANSFERS
    where CREDIT_TRANSFERS.TO_IP = '192.168.0.0' and
          CREDIT_TRANSFERS.FROM_IP like :VAR_CLIENT_IP and
          (CREDIT_TRANSFERS.CLIENT_IP = 'Minigame Fichas' or
          CREDIT_TRANSFERS.CLIENT_IP = 'Minigame Nada' or
          CREDIT_TRANSFERS.CLIENT_IP = 'Minigame Premio') and
          CREDIT_TRANSFERS.TIME_STAMP > :VAR_FROM and
          CREDIT_TRANSFERS.TIME_STAMP < :VAR_TO
    into :RES_MINIGAME_BET;
    if ( RES_MINIGAME_BET is null ) then
       RES_MINIGAME_BET = 0;
    select (sum(CREDIT_TRANSFERS.CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from CREDIT_TRANSFERS
    where CREDIT_TRANSFERS.TO_IP like :VAR_CLIENT_IP and
          CREDIT_TRANSFERS.FROM_IP = '192.168.0.0' and
          (CREDIT_TRANSFERS.CLIENT_IP = 'Minigame Fichas' or
          CREDIT_TRANSFERS.CLIENT_IP = 'Minigame Nada' or
          CREDIT_TRANSFERS.CLIENT_IP = 'Minigame Premio') and
          CREDIT_TRANSFERS.TIME_STAMP > :VAR_FROM and
          CREDIT_TRANSFERS.TIME_STAMP < :VAR_TO
    into :RES_MINIGAME_WIN;
    if ( RES_MINIGAME_WIN is null ) then
       RES_MINIGAME_WIN = 0;
    --jackpots
    select (sum(CREDIT_TRANSFERS.CREDIT_VALUE) * :M_COEFF) / cast(:C_COEFF as
    numeric (18, 4))
    from CREDIT_TRANSFERS
    where CREDIT_TRANSFERS.TO_IP like :VAR_CLIENT_IP and
          CREDIT_TRANSFERS.FROM_IP = '192.168.0.0' and
          CREDIT_TRANSFERS.CLIENT_IP = 'Jackpot Win' and
          CREDIT_TRANSFERS.TIME_STAMP > :VAR_FROM and
          CREDIT_TRANSFERS.TIME_STAMP < :VAR_TO
    into :RES_JACKPOTS_OUT;
    if ( RES_JACKPOTS_OUT is null ) then
       RES_JACKPOTS_OUT = 0;

--poracunamo se vrednosti TMP_ in PERCENT-e..
    RES_PROFIT = RES_IN-RES_OUT;
    RES_MINIGAME_PROFIT=RES_MINIGAME_BET-RES_MINIGAME_WIN;

    if ( RES_BET is not null and RES_BET <> 0 ) then
      RES_BET_PROFIT_PERCENT = cast(cast((RES_PROFIT)*100/RES_BET as numeric(13,2))as varchar(13)) || ' %';
    else
      RES_BET_PROFIT_PERCENT ='0,00 %';

    if ( RES_IN is not null and RES_IN <> 0 ) then
      RES_PAYIN_PROFIT_PERCENT = cast(cast((RES_PROFIT)*100/RES_IN as numeric(13,2))as varchar(13)) || ' %';
    else
      RES_PAYIN_PROFIT_PERCENT ='0,00 %';

    if ( RES_IN is not null and RES_IN <> 0 ) then
      RES_PAYBACK_PERCENT = cast(cast(RES_OUT*100/RES_IN as numeric(13,2))as varchar(13)) || ' %';
    else
      RES_PAYBACK_PERCENT ='100,00 %';

    if ( RES_MINIGAME_BET is not null and RES_MINIGAME_BET <> 0 ) then
      RES_MINIGAME_PAYBACK_PERCENT = cast(cast(RES_MINIGAME_WIN*100/RES_MINIGAME_BET as numeric(13,2))as varchar(13)) || ' %';
    else
      RES_MINIGAME_PAYBACK_PERCENT ='100,00 %';

suspend;
END;
^


CREATE or ALTER PROCEDURE LOG_TOTALS_ALL(
  VAR_COUNTER_ID_SHIFT BIGINT)
RETURNS(
  RES_CLIENT_IP VARCHAR(15) CHARACTER SET WIN1250,
  RES_CLIENT_CAPTION VARCHAR(40) CHARACTER SET WIN1250,
  RES_NONRESTRICTED_BALANCE NUMERIC(18, 2),
  RES_CASHABLE_BALANCE NUMERIC(18, 2),
  RES_RESTRICTED_BALANCE NUMERIC(18, 2),
  RES_FICHAS_BALANCE NUMERIC(18, 2),
  RES_RESERVA_BALANCE NUMERIC(18, 2),
  RES_BANCO_BALANCE NUMERIC(18, 2),
  RES_TOTAL_IN NUMERIC(18, 2),
  RES_TOTAL_OUT NUMERIC(18, 2),
  RES_TOTAL_BETS NUMERIC(18, 2),
  RES_TOTAL_WINS NUMERIC(18, 2),
  RES_TOTAL_RES_BETS NUMERIC(18, 2),
  RES_TOTAL_NONRES_BETS NUMERIC(18, 2),
  RES_BILL_IN NUMERIC(18, 2),
  RES_BILL_OUT NUMERIC(18, 2),
  RES_STACKER_TOTAL NUMERIC(18, 2),
  RES_BILLS_IN_STACKER BIGINT,
  RES_COIN_IN NUMERIC(18, 2),
  RES_COIN_OUT NUMERIC(18, 2),
  RES_COINS_TO_CASHBOX BIGINT,
  RES_COINS_TO_HOPPER BIGINT,
  RES_COIN_HOPPER_LEVEL BIGINT,
  RES_ELECTRONIC_IN NUMERIC(18, 2),
  RES_ELECTRONIC_OUT NUMERIC(18, 2),
  RES_ELECTRONIC_CASH_IN_CENTS NUMERIC(18, 2),
  RES_ELECTRONIC_CASH_OUT_CENTS NUMERIC(18, 2),
  RES_ELECTRONIC_RES_IN_CENTS NUMERIC(18, 2),
  RES_ELECTRONIC_RES_OUT_CENTS NUMERIC(18, 2),
  RES_ELECTRONIC_NONRES_IN_CENTS NUMERIC(18, 2),
  RES_ELECTRONIC_NONRES_OUT_CENTS NUMERIC(18, 2),
  RES_HANDPAY NUMERIC(18, 2),
  RES_ADMIN_KEY_IN NUMERIC(18, 2),
  RES_ADMIN_KEY_OUT NUMERIC(18, 2),
  RES_BONUS_CASH_IN_CENTS NUMERIC(18, 2),
  RES_BONUS_NONRES_IN_CENTS NUMERIC(18, 2),
  RES_BONUS_OUT NUMERIC(18, 2),
  RES_TICKETS_IN_QTY BIGINT,
  RES_TICKETS_OUT_QTY BIGINT,
  RES_TICKET_IN NUMERIC(18, 2),
  RES_TICKET_OUT NUMERIC(18, 2),
  RES_TICKET_CASH_IN NUMERIC(18, 2),
  RES_TICKET_CASH_OUT NUMERIC(18, 2),
  RES_TICKET_RES_IN NUMERIC(18, 2),
  RES_TICKET_RES_OUT NUMERIC(18, 2),
  RES_TICKET_NONRES_IN NUMERIC(18, 2),
  RES_JACKPOT_WIN NUMERIC(18, 2),
  RES_JACKPOTS_WON BIGINT,
  RES_BET_PROFIT_PERCENT VARCHAR(15) CHARACTER SET WIN1250,
  RES_PAYIN_PROFIT_PERCENT VARCHAR(15) CHARACTER SET WIN1250,
  RES_PAYBACK_PERCENT VARCHAR(15) CHARACTER SET WIN1250,
  RES_GAMES_PLAYED BIGINT,
  RES_GAMES_WON BIGINT,
  RES_GAMES_LOST BIGINT,
  RES_GAMES_SINCE_POWER_UP BIGINT,
  RES_GAMES_SINCE_DOOR_CLOSE BIGINT,
  RES_POWER_UP_COUNT BIGINT,
  RES_DOOR_CLOSE_COUNT BIGINT,
  RES_CREDITOS_TOTAL NUMERIC(18, 2),
  RES_RESERVA_TOTAL NUMERIC(18, 2),
  RES_BANCO_TOTAL NUMERIC(18, 2),
  RES_FICHAS_TOTAL NUMERIC(18, 2),
  RES_RESERVA_TO_CREDITOS NUMERIC(18, 2),
  RES_BANCO_TO_CREDITOS NUMERIC(18, 2),
  RES_FICHAS_TO_BANCO NUMERIC(18, 2),
  RES_RETURN_CHANGE_TOTAL NUMERIC(18, 2),
  RES_PAYOUT_ROUNDED_TOTAL NUMERIC(18, 2),
  RES_CYCLES_COMPLETED BIGINT,
  RES_FG_TOTAL_BET NUMERIC(18, 2),
  RES_FG_FICHAS_WIN NUMERIC(18, 2),
  RES_FG_PREMIO_WIN NUMERIC(18, 2),
  RES_FG_NADA_WIN NUMERIC(18, 2),
  RES_FG_RES_FICHAS_COUNT BIGINT,
  RES_FG_RES_PREMIO_COUNT BIGINT,
  RES_FG_RES_NADA_COUNT BIGINT,
  RES_FG_RES_MYSTERY_COUNT BIGINT,
  RES_FG_TOTAL_GAMES BIGINT,
  RES_FG_20_GAMES BIGINT,
  RES_FG_40_GAMES BIGINT,
  RES_FG_50_GAMES BIGINT,
  RES_FG_60_GAMES BIGINT,
  RES_FG_80_GAMES BIGINT,
  RES_FG_100_GAMES BIGINT,
  RES_FG_200_GAMES BIGINT,
  RES_FG_300_GAMES BIGINT,
  RES_FG_600_GAMES BIGINT,
  RES_COUNTING_FROM TIMESTAMP)
AS
DECLARE VARIABLE C_COEFF INTEGER;
DECLARE VARIABLE M_COEFF INTEGER;
DECLARE VARIABLE TMP_NONRESTRICTED_BALANCE NUMERIC(18, 2);
DECLARE VARIABLE TMP_CASHABLE_BALANCE NUMERIC(18, 2);
DECLARE VARIABLE TMP_RESTRICTED_BALANCE NUMERIC(18, 2);
DECLARE VARIABLE TMP_FICHAS_BALANCE NUMERIC(18, 2);
DECLARE VARIABLE TMP_RESERVA_BALANCE NUMERIC(18, 2);
DECLARE VARIABLE TMP_BANCO_BALANCE NUMERIC(18, 2);
DECLARE VARIABLE TMP_TOTAL_IN NUMERIC(18, 2);
DECLARE VARIABLE TMP_TOTAL_OUT NUMERIC(18, 2);
DECLARE VARIABLE TMP_TOTAL_BETS NUMERIC(18, 2);
DECLARE VARIABLE TMP_TOTAL_WINS NUMERIC(18, 2);
DECLARE VARIABLE TMP_TOTAL_RES_BETS NUMERIC(18, 2);
DECLARE VARIABLE TMP_TOTAL_NONRES_BETS NUMERIC(18, 2);
DECLARE VARIABLE TMP_BILL_IN NUMERIC(18, 2);
DECLARE VARIABLE TMP_BILL_OUT NUMERIC(18, 2);
DECLARE VARIABLE TMP_STACKER_TOTAL NUMERIC(18, 2);
DECLARE VARIABLE TMP_BILLS_IN_STACKER BIGINT;
DECLARE VARIABLE TMP_COIN_IN NUMERIC(18, 2);
DECLARE VARIABLE TMP_COIN_OUT NUMERIC(18, 2);
DECLARE VARIABLE TMP_COINS_TO_CASHBOX BIGINT;
DECLARE VARIABLE TMP_COINS_TO_HOPPER BIGINT;
DECLARE VARIABLE TMP_COIN_HOPPER_LEVEL BIGINT;
DECLARE VARIABLE TMP_ELECTRONIC_IN NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECTRONIC_OUT NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECTRONIC_CASH_IN_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECTRONIC_CASH_OUT_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECTRONIC_RES_IN_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECTRONIC_RES_OUT_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECTRONIC_NONRES_IN_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECTRONIC_NONRES_OUT_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_HANDPAY NUMERIC(18, 2);
DECLARE VARIABLE TMP_ADMIN_KEY_IN NUMERIC(18, 2);
DECLARE VARIABLE TMP_ADMIN_KEY_OUT NUMERIC(18, 2);
DECLARE VARIABLE TMP_BONUS_CASH_IN_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_BONUS_NONRES_IN_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_BONUS_OUT NUMERIC(18, 2);
DECLARE VARIABLE TMP_TICKETS_IN_QTY NUMERIC(18, 2);
DECLARE VARIABLE TMP_TICKETS_OUT_QTY NUMERIC(18, 2);
DECLARE VARIABLE TMP_TICKET_IN NUMERIC(18, 2);
DECLARE VARIABLE TMP_TICKET_OUT NUMERIC(18, 2);
DECLARE VARIABLE TMP_TICKET_CASH_IN NUMERIC(18, 2);
DECLARE VARIABLE TMP_TICKET_CASH_OUT NUMERIC(18, 2);
DECLARE VARIABLE TMP_TICKET_RES_IN NUMERIC(18, 2);
DECLARE VARIABLE TMP_TICKET_RES_OUT NUMERIC(18, 2);
DECLARE VARIABLE TMP_TICKET_NONRES_IN NUMERIC(18, 2);
DECLARE VARIABLE TMP_JACKPOT_WIN NUMERIC(18, 2);
DECLARE VARIABLE TMP_JACKPOTS_WON NUMERIC(18, 2);
DECLARE VARIABLE TMP_GAMES_PLAYED BIGINT;
DECLARE VARIABLE TMP_GAMES_WON BIGINT;
DECLARE VARIABLE TMP_GAMES_LOST BIGINT;
DECLARE VARIABLE TMP_GAMES_SINCE_POWER_UP BIGINT;
DECLARE VARIABLE TMP_GAMES_SINCE_DOOR_CLOSE BIGINT;
DECLARE VARIABLE TMP_POWER_UP_COUNT BIGINT;
DECLARE VARIABLE TMP_DOOR_CLOSE_COUNT BIGINT;
DECLARE VARIABLE TMP_TICKET_RESTRICTED_IN NUMERIC(18, 2);
DECLARE VARIABLE TMP_TICKET_RESTRICTED_OUT NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECT_CASH_IN_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECT_CASH_OUT_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECT_RES_IN_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECT_RES_OUT_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECT_NONRES_IN_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECT_NONRES_OUT_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_CREDITOS_TOTAL NUMERIC(18, 2);
DECLARE VARIABLE TMP_RESERVA_TOTAL NUMERIC(18, 2);
DECLARE VARIABLE TMP_BANCO_TOTAL NUMERIC(18, 2);
DECLARE VARIABLE TMP_FICHAS_TOTAL NUMERIC(18, 2);
DECLARE VARIABLE TMP_RESERVA_TO_CREDITOS NUMERIC(18, 2);
DECLARE VARIABLE TMP_BANCO_TO_CREDITOS NUMERIC(18, 2);
DECLARE VARIABLE TMP_FICHAS_TO_BANCO NUMERIC(18, 2);
DECLARE VARIABLE TMP_RETURN_CHANGE_TOTAL NUMERIC(18, 2);
DECLARE VARIABLE TMP_PAYOUT_ROUNDED_TOTAL NUMERIC(18, 2);
DECLARE VARIABLE TMP_CYCLES_COMPLETED BIGINT;
DECLARE VARIABLE TMP_FG_TOTAL_BET NUMERIC(18, 2);
DECLARE VARIABLE TMP_FG_FICHAS_WIN NUMERIC(18, 2);
DECLARE VARIABLE TMP_FG_PREMIO_WIN NUMERIC(18, 2);
DECLARE VARIABLE TMP_FG_NADA_WIN NUMERIC(18, 2);
DECLARE VARIABLE TMP_FG_RES_FICHAS_COUNT BIGINT;
DECLARE VARIABLE TMP_FG_RES_PREMIO_COUNT BIGINT;
DECLARE VARIABLE TMP_FG_RES_NADA_COUNT BIGINT;
DECLARE VARIABLE TMP_FG_RES_MYSTERY_COUNT BIGINT;
DECLARE VARIABLE TMP_FG_TOTAL_GAMES BIGINT;
DECLARE VARIABLE TMP_FG_20_GAMES BIGINT;
DECLARE VARIABLE TMP_FG_40_GAMES BIGINT;
DECLARE VARIABLE TMP_FG_50_GAMES BIGINT;
DECLARE VARIABLE TMP_FG_60_GAMES BIGINT;
DECLARE VARIABLE TMP_FG_80_GAMES BIGINT;
DECLARE VARIABLE TMP_FG_100_GAMES BIGINT;
DECLARE VARIABLE TMP_FG_200_GAMES BIGINT;
DECLARE VARIABLE TMP_FG_300_GAMES BIGINT;
DECLARE VARIABLE TMP_FG_600_GAMES BIGINT;
DECLARE VARIABLE TMP_MIN_COUNTING_FROM TIMESTAMP;
BEGIN

select RES_NUM_VALUE
from GET_PARAM('192.168.0.0', 'BILL_CURRENCY_TO_CREDIT', 11)
into :M_COEFF;
select RES_NUM_VALUE
from GET_PARAM('192.168.0.0', 'BILL_CREDIT_TO_CURRENCY', 11)
into :C_COEFF;
if (M_COEFF is null or (0=M_COEFF)) then
   M_COEFF = 1;
if (C_COEFF is null or (0=C_COEFF)) then
   C_COEFF = 1;

TMP_NONRESTRICTED_BALANCE = 0;
TMP_CASHABLE_BALANCE = 0;
TMP_RESTRICTED_BALANCE = 0;
TMP_FICHAS_BALANCE = 0;
TMP_RESERVA_BALANCE = 0;
TMP_BANCO_BALANCE = 0;
TMP_TOTAL_IN = 0;
TMP_TOTAL_OUT = 0;
TMP_TOTAL_BETS = 0;
TMP_TOTAL_WINS = 0;
TMP_TOTAL_RES_BETS = 0;
TMP_TOTAL_NONRES_BETS = 0;
TMP_BILL_IN = 0;
TMP_BILL_OUT = 0;
TMP_STACKER_TOTAL = 0;
TMP_BILLS_IN_STACKER = 0;
TMP_COIN_IN = 0;
TMP_COIN_OUT = 0;
TMP_COINS_TO_CASHBOX = 0;
TMP_COINS_TO_HOPPER = 0;
TMP_COIN_HOPPER_LEVEL = 0;
TMP_ELECTRONIC_IN = 0;
TMP_ELECTRONIC_OUT = 0;
TMP_ELECTRONIC_CASH_IN_CENTS = 0;
TMP_ELECTRONIC_CASH_OUT_CENTS = 0;
TMP_ELECTRONIC_RES_IN_CENTS = 0;
TMP_ELECTRONIC_RES_OUT_CENTS = 0;
TMP_ELECTRONIC_NONRES_IN_CENTS = 0;
TMP_ELECTRONIC_NONRES_OUT_CENTS = 0;
TMP_HANDPAY = 0;
TMP_ADMIN_KEY_IN = 0;
TMP_ADMIN_KEY_OUT = 0;
TMP_BONUS_CASH_IN_CENTS = 0;
TMP_BONUS_NONRES_IN_CENTS = 0;
TMP_BONUS_OUT = 0;
TMP_TICKETS_IN_QTY = 0;
TMP_TICKETS_OUT_QTY = 0;
TMP_TICKET_IN = 0;
TMP_TICKET_OUT = 0;
TMP_TICKET_CASH_IN = 0;
TMP_TICKET_CASH_OUT = 0;
TMP_TICKET_RES_IN = 0;
TMP_TICKET_RES_OUT = 0;
TMP_TICKET_NONRES_IN = 0;
TMP_JACKPOT_WIN = 0;
TMP_JACKPOTS_WON = 0;
TMP_GAMES_PLAYED = 0;
TMP_GAMES_WON = 0;
TMP_GAMES_LOST = 0;
TMP_GAMES_SINCE_POWER_UP = 0;
TMP_GAMES_SINCE_DOOR_CLOSE = 0;
TMP_POWER_UP_COUNT = 0;
TMP_DOOR_CLOSE_COUNT = 0;

TMP_CREDITOS_TOTAL = 0;
TMP_RESERVA_TOTAL = 0;
TMP_BANCO_TOTAL = 0;
TMP_FICHAS_TOTAL = 0;
TMP_RESERVA_TO_CREDITOS = 0;
TMP_BANCO_TO_CREDITOS = 0;
TMP_FICHAS_TO_BANCO = 0;
TMP_RETURN_CHANGE_TOTAL = 0;
TMP_PAYOUT_ROUNDED_TOTAL = 0;
TMP_CYCLES_COMPLETED = 0;
TMP_FG_TOTAL_BET = 0;
TMP_FG_FICHAS_WIN = 0;
TMP_FG_PREMIO_WIN = 0;
TMP_FG_NADA_WIN = 0;
TMP_FG_RES_FICHAS_COUNT = 0;
TMP_FG_RES_PREMIO_COUNT = 0;
TMP_FG_RES_NADA_COUNT = 0;
TMP_FG_RES_MYSTERY_COUNT = 0;
TMP_FG_TOTAL_GAMES = 0;
TMP_FG_20_GAMES = 0;
TMP_FG_40_GAMES = 0;
TMP_FG_50_GAMES = 0;
TMP_FG_60_GAMES = 0;
TMP_FG_80_GAMES = 0;
TMP_FG_100_GAMES = 0;
TMP_FG_200_GAMES = 0;
TMP_FG_300_GAMES = 0;
TMP_FG_600_GAMES = 0;
TMP_MIN_COUNTING_FROM = NULL;

for select case CLIENT_IP
                when '192.168.0.0' then 'Roulette'
                when '192.168.0.1' then 'Player 1'
                when '192.168.0.2' then 'Player 2'
                when '192.168.0.3' then 'Player 3'
                when '192.168.0.4' then 'Player 4'
                when '192.168.0.5' then 'Player 5'
                when '192.168.0.6' then 'Player 6'
                when '192.168.0.7' then 'Player 7'
                when '192.168.0.8' then 'Player 8'
                when '192.168.0.9' then 'Player 9'
                when '192.168.0.10' then 'Player 10'
                when '192.168.0.11' then 'Player 11'
                when '192.168.0.12' then 'Player 12'
                when '192.168.0.13' then 'Player 13'
                when '192.168.0.14' then 'Player 14'
                when '192.168.0.15' then 'Player 15'
                when '192.168.0.16' then 'Player 16'
                when '192.168.0.17' then 'Player 17'
                when '192.168.0.18' then 'Player 18'
                when '192.168.0.19' then 'Player 19'
                when '192.168.0.20' then 'Player 20'
                when '192.168.0.21' then 'Player 21'
                when '192.168.0.22' then 'Player 22'
                when '192.168.0.23' then 'Player 23'
                when '192.168.0.24' then 'Player 24'
                when '192.168.0.25' then 'Player 25'
                when '192.168.0.26' then 'Player 26'
                when '192.168.0.27' then 'Player 27'
                when '192.168.0.28' then 'Player 28'
                when '192.168.0.29' then 'Player 29'
                when '192.168.0.30' then 'Player 30'
                when '192.168.0.31' then 'Player 31'
                when '192.168.0.32' then 'Player 32'
                when '192.168.0.33' then 'Player 33'
                when '192.168.0.34' then 'Player 34'
                when '192.168.0.35' then 'Player 35'
                when '192.168.0.36' then 'Player 36'
                when '192.168.0.37' then 'Player 37'
                when '192.168.0.38' then 'Player 38'
                when '192.168.0.39' then 'Player 39'
                when '192.168.0.40' then 'Player 40'
                when '192.168.0.41' then 'Player 41'
                when '192.168.0.42' then 'Player 42'
                when '192.168.0.43' then 'Player 43'
                when '192.168.0.44' then 'Player 44'
                when '192.168.0.45' then 'Player 45'
                when '192.168.0.46' then 'Player 46'
                when '192.168.0.47' then 'Player 47'
                when '192.168.0.48' then 'Player 48'
                when '192.168.0.49' then 'Player 49'
                when '192.168.0.50' then 'Player 50'
                else CLIENT_IP
                end as DESCRIPTION,
                case CLIENT_IP
                when '192.168.0.0' then 999/*skupno je zadnji*/
                when '192.168.0.1' then 1
                when '192.168.0.2' then 2
                when '192.168.0.3' then 3
                when '192.168.0.4' then 4
                when '192.168.0.5' then 5
                when '192.168.0.6' then 6
                when '192.168.0.7' then 7
                when '192.168.0.8' then 8
                when '192.168.0.9' then 9
                when '192.168.0.10' then 10
                when '192.168.0.11' then 11
                when '192.168.0.12' then 12
                when '192.168.0.13' then 13
                when '192.168.0.14' then 14
                when '192.168.0.15' then 15
                when '192.168.0.16' then 16
                when '192.168.0.17' then 17
                when '192.168.0.18' then 18
                when '192.168.0.19' then 19
                when '192.168.0.20' then 20
                when '192.168.0.21' then 21
                when '192.168.0.22' then 22
                when '192.168.0.23' then 23
                when '192.168.0.24' then 24
                when '192.168.0.25' then 25
                when '192.168.0.26' then 26
                when '192.168.0.27' then 27
                when '192.168.0.28' then 28
                when '192.168.0.29' then 29
                when '192.168.0.30' then 30
                when '192.168.0.31' then 31
                when '192.168.0.32' then 32
                when '192.168.0.33' then 33
                when '192.168.0.34' then 34
                when '192.168.0.35' then 35
                when '192.168.0.36' then 36
                when '192.168.0.37' then 37
                when '192.168.0.38' then 38
                when '192.168.0.39' then 39
                when '192.168.0.40' then 40
                when '192.168.0.41' then 41
                when '192.168.0.42' then 42
                when '192.168.0.43' then 43
                when '192.168.0.44' then 44
                when '192.168.0.45' then 45
                when '192.168.0.46' then 46
                when '192.168.0.47' then 47
                when '192.168.0.48' then 48
                when '192.168.0.49' then 49
                when '192.168.0.50' then 50
                else 51/*po potrebi dodaj - tale STATION NUMBER SE UPORABLJA SAMO ZA SORTIRANJE, ker STRING SE SORTIRA Player 1, Player 10, Player 11, Player 2,...*/
           end as STATION_NUMBER,
           CLIENT_IP
    from DIGITAL_COUNTERS
    where COUNTER_INDEX<1000
    and   COUNTER_INDEX>=0
    group by CLIENT_IP
    order by 2 ascending, CLIENT_IP ASCENDING
    into :RES_CLIENT_CAPTION,
         :RES_TOTAL_IN, --tega ne rabimo, gre v zacasno spremenljivko
         :RES_CLIENT_IP
do begin

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+10)
   into RES_NONRESTRICTED_BALANCE;
   TMP_NONRESTRICTED_BALANCE = TMP_NONRESTRICTED_BALANCE+RES_NONRESTRICTED_BALANCE;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4)),
          RES_COUNTING_FROM
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+11)
   into :RES_CASHABLE_BALANCE,
        :RES_COUNTING_FROM;
   TMP_CASHABLE_BALANCE = TMP_CASHABLE_BALANCE+RES_CASHABLE_BALANCE;
   if (TMP_MIN_COUNTING_FROM is null or RES_COUNTING_FROM<TMP_MIN_COUNTING_FROM ) then
      TMP_MIN_COUNTING_FROM = RES_COUNTING_FROM;--zapomnemo si najmanjsi datum za ALL

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+12)
   into RES_RESTRICTED_BALANCE;
   TMP_RESTRICTED_BALANCE = TMP_RESTRICTED_BALANCE+RES_RESTRICTED_BALANCE;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+13)
   into RES_FICHAS_BALANCE;
   TMP_FICHAS_BALANCE = TMP_FICHAS_BALANCE+RES_FICHAS_BALANCE;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+14)
   into RES_RESERVA_BALANCE;
   TMP_RESERVA_BALANCE = TMP_RESERVA_BALANCE+RES_RESERVA_BALANCE;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+15)
   into RES_BANCO_BALANCE;
   TMP_BANCO_BALANCE = TMP_BANCO_BALANCE+RES_BANCO_BALANCE;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+51)
   into RES_TOTAL_IN;
   TMP_TOTAL_IN = TMP_TOTAL_IN+RES_TOTAL_IN;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+52)
   into RES_TOTAL_OUT;
   TMP_TOTAL_OUT = TMP_TOTAL_OUT+RES_TOTAL_OUT;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+53)
   into RES_TOTAL_BETS;
   TMP_TOTAL_BETS = TMP_TOTAL_BETS+RES_TOTAL_BETS;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+54)
   into RES_TOTAL_WINS;
   TMP_TOTAL_WINS = TMP_TOTAL_WINS+RES_TOTAL_WINS;

       select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+55)
       into RES_TOTAL_RES_BETS;
       TMP_TOTAL_RES_BETS = TMP_TOTAL_RES_BETS+RES_TOTAL_RES_BETS;

       select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+56)
       into RES_TOTAL_NONRES_BETS;
       TMP_TOTAL_NONRES_BETS = TMP_TOTAL_NONRES_BETS+RES_TOTAL_NONRES_BETS;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+322)
   into RES_BILL_IN;
   TMP_BILL_IN = TMP_BILL_IN+RES_BILL_IN;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+324)
   into RES_BILL_OUT;
   TMP_BILL_OUT = TMP_BILL_OUT+RES_BILL_OUT;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+321)
   into RES_STACKER_TOTAL;
   TMP_STACKER_TOTAL = TMP_STACKER_TOTAL+RES_STACKER_TOTAL;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+320)
   into RES_BILLS_IN_STACKER;
   TMP_BILLS_IN_STACKER = TMP_BILLS_IN_STACKER+RES_BILLS_IN_STACKER;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+400)
   into RES_COIN_IN;
   TMP_COIN_IN = TMP_COIN_IN+RES_COIN_IN;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+401)
   into RES_COIN_OUT;
   TMP_COIN_OUT = TMP_COIN_OUT+RES_COIN_OUT;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+600)
   into RES_COINS_TO_CASHBOX;
   TMP_COINS_TO_CASHBOX = TMP_COINS_TO_CASHBOX+RES_COINS_TO_CASHBOX;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+600)
   into RES_COINS_TO_HOPPER;
   TMP_COINS_TO_HOPPER = TMP_COINS_TO_HOPPER+RES_COINS_TO_HOPPER;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+600)
   into RES_COIN_HOPPER_LEVEL;
   TMP_COIN_HOPPER_LEVEL = TMP_COIN_HOPPER_LEVEL+RES_COIN_HOPPER_LEVEL;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+500)
   into RES_ELECTRONIC_IN;
   TMP_ELECTRONIC_IN = TMP_ELECTRONIC_IN+RES_ELECTRONIC_IN;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+501)
   into RES_ELECTRONIC_OUT;
   TMP_ELECTRONIC_OUT = TMP_ELECTRONIC_OUT+RES_ELECTRONIC_OUT;

       select (RES_COUNTER_VALUE*1)/cast(100 as numeric(18,4))/*tevec teje v centih*/
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+505)
       into RES_ELECTRONIC_CASH_IN_CENTS;
       TMP_ELECTRONIC_CASH_IN_CENTS = TMP_ELECTRONIC_CASH_IN_CENTS+RES_ELECTRONIC_CASH_IN_CENTS;

       select (RES_COUNTER_VALUE*1)/cast(100 as numeric(18,4))/*tevec teje v centih*/
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+506)
       into RES_ELECTRONIC_CASH_OUT_CENTS;
       TMP_ELECTRONIC_CASH_OUT_CENTS = TMP_ELECTRONIC_CASH_OUT_CENTS+RES_ELECTRONIC_CASH_OUT_CENTS;

       select (RES_COUNTER_VALUE*1)/cast(100 as numeric(18,4))/*tevec teje v centih*/
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+509)
       into RES_ELECTRONIC_RES_IN_CENTS;
       TMP_ELECTRONIC_RES_IN_CENTS = TMP_ELECTRONIC_RES_IN_CENTS+RES_ELECTRONIC_RES_IN_CENTS;

       select (RES_COUNTER_VALUE*1)/cast(100 as numeric(18,4))/*tevec teje v centih*/
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+510)
       into RES_ELECTRONIC_RES_OUT_CENTS;
       TMP_ELECTRONIC_RES_OUT_CENTS = TMP_ELECTRONIC_RES_OUT_CENTS+RES_ELECTRONIC_RES_OUT_CENTS;

       select (RES_COUNTER_VALUE*1)/cast(100 as numeric(18,4))/*tevec teje v centih*/
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+513)
       into RES_ELECTRONIC_NONRES_IN_CENTS;
       TMP_ELECTRONIC_NONRES_IN_CENTS = TMP_ELECTRONIC_NONRES_IN_CENTS+RES_ELECTRONIC_NONRES_IN_CENTS;

       select (RES_COUNTER_VALUE*1)/cast(100 as numeric(18,4))/*tevec teje v centih*/
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+514)
       into RES_ELECTRONIC_NONRES_OUT_CENTS;
       TMP_ELECTRONIC_NONRES_OUT_CENTS = TMP_ELECTRONIC_NONRES_OUT_CENTS+RES_ELECTRONIC_NONRES_OUT_CENTS;

       select RES_COUNTER_VALUE
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+600)
       into RES_TICKETS_IN_QTY;
       TMP_TICKETS_IN_QTY = TMP_TICKETS_IN_QTY+RES_TICKETS_IN_QTY;

       select RES_COUNTER_VALUE
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+601)
       into RES_TICKETS_OUT_QTY;
       TMP_TICKETS_OUT_QTY = TMP_TICKETS_OUT_QTY+RES_TICKETS_OUT_QTY;

       select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+609)
       into RES_TICKET_CASH_IN;
       TMP_TICKET_CASH_IN = TMP_TICKET_CASH_IN+RES_TICKET_CASH_IN;

       select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+610)
       into RES_TICKET_CASH_OUT;
       TMP_TICKET_CASH_OUT = TMP_TICKET_CASH_OUT+RES_TICKET_CASH_OUT;

       select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+615)
       into RES_TICKET_RES_IN;
       TMP_TICKET_RES_IN = TMP_TICKET_RES_IN+RES_TICKET_RES_IN;

       select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+616)
       into RES_TICKET_RES_OUT;
       TMP_TICKET_RES_OUT = TMP_TICKET_RES_OUT+RES_TICKET_RES_OUT;

       select (RES_COUNTER_VALUE*1)/cast(100 as numeric(18,4))/*tevec teje v centih*/
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+617)
       into RES_TICKET_NONRES_IN;
       TMP_TICKET_NONRES_IN = TMP_TICKET_NONRES_IN+RES_TICKET_NONRES_IN;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+504)
   into RES_HANDPAY;
   TMP_HANDPAY = TMP_HANDPAY+RES_HANDPAY;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+700)
   into RES_ADMIN_KEY_IN;
   TMP_ADMIN_KEY_IN = TMP_ADMIN_KEY_IN+RES_ADMIN_KEY_IN;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+701)
   into RES_ADMIN_KEY_OUT;
   TMP_ADMIN_KEY_OUT = TMP_ADMIN_KEY_OUT+RES_ADMIN_KEY_OUT;

       select (RES_COUNTER_VALUE*1)/cast(100 as numeric(18,4))/*tevec teje v centih*/
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+557)
       into RES_BONUS_CASH_IN_CENTS;
       TMP_BONUS_CASH_IN_CENTS = TMP_BONUS_CASH_IN_CENTS+RES_BONUS_CASH_IN_CENTS;

       select (RES_COUNTER_VALUE*1)/cast(100 as numeric(18,4))/*tevec teje v centih*/
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+559)
       into RES_BONUS_NONRES_IN_CENTS;
       TMP_BONUS_NONRES_IN_CENTS = TMP_BONUS_NONRES_IN_CENTS+RES_BONUS_NONRES_IN_CENTS;

       select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+561)
       into RES_BONUS_OUT;
       TMP_BONUS_OUT = TMP_BONUS_OUT+RES_BONUS_OUT;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+602)
   into RES_TICKET_IN;
   TMP_TICKET_IN = TMP_TICKET_IN+RES_TICKET_IN;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+603)
   into RES_TICKET_OUT;
   TMP_TICKET_OUT = TMP_TICKET_OUT+RES_TICKET_OUT;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+517)
   into RES_JACKPOT_WIN;
   TMP_JACKPOT_WIN = TMP_JACKPOT_WIN+RES_JACKPOT_WIN;

   select RES_COUNTER_VALUE/*tevec teje kolikokrat se je jackpot zgodil*/
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+518)
   into RES_JACKPOTS_WON;
   TMP_JACKPOTS_WON = TMP_JACKPOTS_WON+RES_JACKPOTS_WON;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+300)
   into RES_GAMES_PLAYED;
   TMP_GAMES_PLAYED = TMP_GAMES_PLAYED+RES_GAMES_PLAYED;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+301)
   into RES_GAMES_WON;
   TMP_GAMES_WON = TMP_GAMES_WON+RES_GAMES_WON;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+302)
   into RES_GAMES_LOST;
   TMP_GAMES_LOST = TMP_GAMES_LOST+RES_GAMES_LOST;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+303)
   into RES_GAMES_SINCE_POWER_UP;
   TMP_GAMES_SINCE_POWER_UP = TMP_GAMES_SINCE_POWER_UP+RES_GAMES_SINCE_POWER_UP;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+304)
   into RES_GAMES_SINCE_DOOR_CLOSE;
   TMP_GAMES_SINCE_DOOR_CLOSE = TMP_GAMES_SINCE_DOOR_CLOSE+RES_GAMES_SINCE_DOOR_CLOSE;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+305)
   into RES_POWER_UP_COUNT;
   TMP_POWER_UP_COUNT = TMP_POWER_UP_COUNT+RES_POWER_UP_COUNT;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+306)
   into RES_DOOR_CLOSE_COUNT;
   TMP_DOOR_CLOSE_COUNT = TMP_DOOR_CLOSE_COUNT+RES_DOOR_CLOSE_COUNT;

   if ( RES_TOTAL_BETS is not null and RES_TOTAL_BETS <> 0 ) then
      RES_BET_PROFIT_PERCENT = cast(cast((RES_TOTAL_BETS-RES_TOTAL_WINS)*100/RES_TOTAL_BETS as numeric(13,2))as varchar(13)) || ' %';
   else
       RES_BET_PROFIT_PERCENT ='0,00 %';

   if ( RES_TOTAL_IN is not null and RES_TOTAL_IN <> 0 ) then
      RES_PAYIN_PROFIT_PERCENT = cast(cast((RES_TOTAL_IN-RES_TOTAL_OUT)*100/RES_TOTAL_IN as numeric(13,2))as varchar(13)) || ' %';
   else
      RES_PAYIN_PROFIT_PERCENT ='0,00 %';

   if ( RES_TOTAL_IN is not null and RES_TOTAL_IN <> 0 ) then
      RES_PAYBACK_PERCENT = cast(cast(RES_TOTAL_OUT*100/RES_TOTAL_IN as numeric(13,2))as varchar(13)) || ' %';
   else
      RES_PAYBACK_PERCENT ='0,00 %';



   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+800)
   into RES_CREDITOS_TOTAL;
   TMP_CREDITOS_TOTAL = TMP_CREDITOS_TOTAL+RES_CREDITOS_TOTAL;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+801)
   into RES_RESERVA_TOTAL;
   TMP_RESERVA_TOTAL = TMP_RESERVA_TOTAL+RES_RESERVA_TOTAL;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+802)
   into RES_BANCO_TOTAL;
   TMP_BANCO_TOTAL = TMP_BANCO_TOTAL+RES_BANCO_TOTAL;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+805)
   into RES_FICHAS_TOTAL;
   TMP_FICHAS_TOTAL = TMP_FICHAS_TOTAL+RES_FICHAS_TOTAL;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+803)
   into RES_RESERVA_TO_CREDITOS;
   TMP_RESERVA_TO_CREDITOS = TMP_RESERVA_TO_CREDITOS+RES_RESERVA_TO_CREDITOS;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+804)
   into RES_BANCO_TO_CREDITOS;
   TMP_BANCO_TO_CREDITOS = TMP_BANCO_TO_CREDITOS+RES_BANCO_TO_CREDITOS;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+808)
   into RES_FICHAS_TO_BANCO;
   TMP_FICHAS_TO_BANCO = TMP_FICHAS_TO_BANCO+RES_FICHAS_TO_BANCO;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+825)
   into RES_RETURN_CHANGE_TOTAL;
   TMP_RETURN_CHANGE_TOTAL = TMP_RETURN_CHANGE_TOTAL+RES_RETURN_CHANGE_TOTAL;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+826)
   into RES_PAYOUT_ROUNDED_TOTAL;
   TMP_PAYOUT_ROUNDED_TOTAL = TMP_PAYOUT_ROUNDED_TOTAL+RES_PAYOUT_ROUNDED_TOTAL;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+820)
   into RES_CYCLES_COMPLETED;
   TMP_CYCLES_COMPLETED = TMP_CYCLES_COMPLETED+RES_CYCLES_COMPLETED;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+809)
   into RES_FG_TOTAL_BET;
   TMP_FG_TOTAL_BET = TMP_FG_TOTAL_BET+RES_FG_TOTAL_BET;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+805)
   into RES_FG_FICHAS_WIN;
   TMP_FG_FICHAS_WIN = TMP_FG_FICHAS_WIN+RES_FG_FICHAS_WIN;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+806)
   into RES_FG_PREMIO_WIN;
   TMP_FG_PREMIO_WIN = TMP_FG_PREMIO_WIN+RES_FG_PREMIO_WIN;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+807)
   into RES_FG_NADA_WIN;
   TMP_FG_NADA_WIN = TMP_FG_NADA_WIN+RES_FG_NADA_WIN;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+821)
   into RES_FG_RES_NADA_COUNT;
   TMP_FG_RES_NADA_COUNT = TMP_FG_RES_NADA_COUNT+RES_FG_RES_NADA_COUNT;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+822)
   into RES_FG_RES_MYSTERY_COUNT;
   TMP_FG_RES_MYSTERY_COUNT = TMP_FG_RES_MYSTERY_COUNT+RES_FG_RES_MYSTERY_COUNT;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+823)
   into RES_FG_RES_PREMIO_COUNT;
   TMP_FG_RES_PREMIO_COUNT = TMP_FG_RES_PREMIO_COUNT+RES_FG_RES_PREMIO_COUNT;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+824)
   into RES_FG_RES_FICHAS_COUNT;
   TMP_FG_RES_FICHAS_COUNT = TMP_FG_RES_FICHAS_COUNT+RES_FG_RES_FICHAS_COUNT;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+810)
   into RES_FG_TOTAL_GAMES;
   TMP_FG_TOTAL_GAMES = TMP_FG_TOTAL_GAMES+RES_FG_TOTAL_GAMES;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+811)
   into RES_FG_20_GAMES;
   TMP_FG_20_GAMES = TMP_FG_20_GAMES+RES_FG_20_GAMES;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+812)
   into RES_FG_40_GAMES;
   TMP_FG_40_GAMES = TMP_FG_40_GAMES+RES_FG_40_GAMES;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+813)
   into RES_FG_50_GAMES;
   TMP_FG_50_GAMES = TMP_FG_50_GAMES+RES_FG_50_GAMES;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+814)
   into RES_FG_60_GAMES;
   TMP_FG_60_GAMES = TMP_FG_60_GAMES+RES_FG_60_GAMES;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+815)
   into RES_FG_80_GAMES;
   TMP_FG_80_GAMES = TMP_FG_80_GAMES+RES_FG_80_GAMES;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+816)
   into RES_FG_100_GAMES;
   TMP_FG_100_GAMES = TMP_FG_100_GAMES+RES_FG_100_GAMES;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+817)
   into RES_FG_200_GAMES;
   TMP_FG_200_GAMES = TMP_FG_200_GAMES+RES_FG_200_GAMES;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+818)
   into RES_FG_300_GAMES;
   TMP_FG_300_GAMES = TMP_FG_300_GAMES+RES_FG_300_GAMES;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, :VAR_COUNTER_ID_SHIFT+819)
   into RES_FG_600_GAMES;
   TMP_FG_600_GAMES = TMP_FG_600_GAMES+RES_FG_600_GAMES;

   suspend;
end

RES_CLIENT_IP = '192.168.0.0';
RES_CLIENT_CAPTION = 'All Players';

RES_NONRESTRICTED_BALANCE = TMP_NONRESTRICTED_BALANCE;
RES_CASHABLE_BALANCE = TMP_CASHABLE_BALANCE;
RES_RESTRICTED_BALANCE = TMP_RESTRICTED_BALANCE;
RES_FICHAS_BALANCE = TMP_FICHAS_BALANCE;
RES_RESERVA_BALANCE = TMP_RESERVA_BALANCE;
RES_BANCO_BALANCE = TMP_BANCO_BALANCE;

RES_TOTAL_IN = TMP_TOTAL_IN;
RES_TOTAL_OUT = TMP_TOTAL_OUT;
RES_TOTAL_BETS = TMP_TOTAL_BETS;
RES_TOTAL_WINS = TMP_TOTAL_WINS;
RES_TOTAL_RES_BETS = TMP_TOTAL_RES_BETS;
RES_TOTAL_NONRES_BETS = TMP_TOTAL_NONRES_BETS;
RES_BILL_IN = TMP_BILL_IN;
RES_BILL_OUT = TMP_BILL_OUT;
RES_STACKER_TOTAL = TMP_STACKER_TOTAL;
RES_BILLS_IN_STACKER = TMP_BILLS_IN_STACKER;
RES_COIN_IN = TMP_COIN_IN;
RES_COIN_OUT = TMP_COIN_OUT;
RES_COINS_TO_CASHBOX = TMP_COINS_TO_CASHBOX;
RES_COINS_TO_HOPPER = TMP_COINS_TO_HOPPER;
RES_COIN_HOPPER_LEVEL = TMP_COIN_HOPPER_LEVEL;
RES_ELECTRONIC_IN = TMP_ELECTRONIC_IN;
RES_ELECTRONIC_OUT = TMP_ELECTRONIC_OUT;
RES_ELECTRONIC_CASH_IN_CENTS = TMP_ELECTRONIC_CASH_IN_CENTS;
RES_ELECTRONIC_CASH_OUT_CENTS = TMP_ELECTRONIC_CASH_OUT_CENTS;
RES_ELECTRONIC_RES_IN_CENTS = TMP_ELECTRONIC_RES_IN_CENTS;
RES_ELECTRONIC_RES_OUT_CENTS = TMP_ELECTRONIC_RES_OUT_CENTS;
RES_ELECTRONIC_NONRES_IN_CENTS = TMP_ELECTRONIC_NONRES_IN_CENTS;
RES_ELECTRONIC_NONRES_OUT_CENTS = TMP_ELECTRONIC_NONRES_OUT_CENTS;
RES_HANDPAY = TMP_HANDPAY;
RES_ADMIN_KEY_IN = TMP_ADMIN_KEY_IN;
RES_ADMIN_KEY_OUT = TMP_ADMIN_KEY_OUT;
RES_BONUS_CASH_IN_CENTS = TMP_BONUS_CASH_IN_CENTS;
RES_BONUS_NONRES_IN_CENTS = TMP_BONUS_NONRES_IN_CENTS;
RES_BONUS_OUT = TMP_BONUS_OUT;
RES_TICKETS_IN_QTY = TMP_TICKETS_IN_QTY;
RES_TICKETS_OUT_QTY = TMP_TICKETS_OUT_QTY;
RES_TICKET_IN = TMP_TICKET_IN;
RES_TICKET_OUT = TMP_TICKET_OUT;
RES_TICKET_CASH_IN = TMP_TICKET_CASH_IN;
RES_TICKET_CASH_OUT = TMP_TICKET_CASH_OUT;
RES_TICKET_RES_IN = TMP_TICKET_RES_IN;
RES_TICKET_RES_OUT = TMP_TICKET_RES_OUT;
RES_TICKET_NONRES_IN = TMP_TICKET_NONRES_IN;
RES_JACKPOT_WIN = TMP_JACKPOT_WIN;
RES_JACKPOTS_WON = TMP_JACKPOTS_WON;
RES_GAMES_PLAYED = TMP_GAMES_PLAYED;
RES_GAMES_WON = TMP_GAMES_WON;
RES_GAMES_LOST = TMP_GAMES_LOST;
RES_GAMES_SINCE_POWER_UP = TMP_GAMES_SINCE_POWER_UP;
RES_GAMES_SINCE_DOOR_CLOSE = TMP_GAMES_SINCE_DOOR_CLOSE;
RES_POWER_UP_COUNT = TMP_POWER_UP_COUNT;
RES_DOOR_CLOSE_COUNT = TMP_DOOR_CLOSE_COUNT;

   if ( RES_TOTAL_BETS is not null and RES_TOTAL_BETS <> 0 ) then
      RES_BET_PROFIT_PERCENT = cast(cast((RES_TOTAL_BETS-RES_TOTAL_WINS)*100/RES_TOTAL_BETS as numeric(13,2))as varchar(13)) || ' %';
   else
       RES_BET_PROFIT_PERCENT ='0,00 %';

   if ( RES_TOTAL_IN is not null and RES_TOTAL_IN <> 0 ) then
      RES_PAYIN_PROFIT_PERCENT = cast(cast((RES_TOTAL_IN-RES_TOTAL_OUT)*100/RES_TOTAL_IN as numeric(13,2))as varchar(13)) || ' %';
   else
      RES_PAYIN_PROFIT_PERCENT ='0,00 %';

   if ( RES_TOTAL_IN is not null and RES_TOTAL_IN <> 0 ) then
      RES_PAYBACK_PERCENT = cast(cast(RES_TOTAL_OUT*100/RES_TOTAL_IN as numeric(13,2))as varchar(13)) || ' %';
   else
      RES_PAYBACK_PERCENT ='0,00 %';

RES_CREDITOS_TOTAL = TMP_CREDITOS_TOTAL;
RES_RESERVA_TOTAL = TMP_RESERVA_TOTAL;
RES_BANCO_TOTAL = TMP_BANCO_TOTAL;
RES_FICHAS_TOTAL = TMP_FICHAS_TOTAL;
RES_RESERVA_TO_CREDITOS = TMP_RESERVA_TO_CREDITOS;
RES_BANCO_TO_CREDITOS = TMP_BANCO_TO_CREDITOS;
RES_FICHAS_TO_BANCO = TMP_FICHAS_TO_BANCO;
RES_RETURN_CHANGE_TOTAL = TMP_RETURN_CHANGE_TOTAL;
RES_PAYOUT_ROUNDED_TOTAL = TMP_PAYOUT_ROUNDED_TOTAL;
RES_CYCLES_COMPLETED = TMP_CYCLES_COMPLETED;
RES_FG_TOTAL_BET = TMP_FG_TOTAL_BET;
RES_FG_FICHAS_WIN = TMP_FG_FICHAS_WIN;
RES_FG_PREMIO_WIN = TMP_FG_PREMIO_WIN;
RES_FG_NADA_WIN = TMP_FG_NADA_WIN;
RES_FG_RES_FICHAS_COUNT = TMP_FG_RES_FICHAS_COUNT;
RES_FG_RES_PREMIO_COUNT = TMP_FG_RES_PREMIO_COUNT;
RES_FG_RES_NADA_COUNT = TMP_FG_RES_NADA_COUNT;
RES_FG_RES_MYSTERY_COUNT = TMP_FG_RES_MYSTERY_COUNT;
RES_FG_TOTAL_GAMES = TMP_FG_TOTAL_GAMES;
RES_FG_20_GAMES = TMP_FG_20_GAMES;
RES_FG_40_GAMES = TMP_FG_40_GAMES;
RES_FG_50_GAMES = TMP_FG_50_GAMES;
RES_FG_60_GAMES = TMP_FG_60_GAMES;
RES_FG_80_GAMES = TMP_FG_80_GAMES;
RES_FG_100_GAMES = TMP_FG_100_GAMES;
RES_FG_200_GAMES = TMP_FG_200_GAMES;
RES_FG_300_GAMES = TMP_FG_300_GAMES;
RES_FG_600_GAMES = TMP_FG_600_GAMES;
RES_COUNTING_FROM = TMP_MIN_COUNTING_FROM;


SUSPEND;
END;
^

CREATE or alter PROCEDURE SUM_DIGITAL_COUNTERS
 ( VAR_CLIENT_IP1 varchar(15),
   VAR_CLIENT_IP2 varchar(15) )
RETURNS
 ( RES_COUNTER_INDEX bigint, RES_COUNTER_SUM_VALUE bigint, RES_RESULT smallint, RES_STR_RESULT varchar(60) )
AS
BEGIN

for select sum(counter_value), counter_index
from DIGITAL_COUNTERS
where client_ip = :VAR_CLIENT_IP1
or    client_ip = :VAR_CLIENT_IP2
group by counter_index
into :RES_COUNTER_SUM_VALUE,
     :RES_COUNTER_INDEX
do begin

    delete from DIGITAL_COUNTERS
    where (CLIENT_IP = :VAR_CLIENT_IP1
    or    CLIENT_IP = :VAR_CLIENT_IP2)
    and   COUNTER_INDEX = :RES_COUNTER_INDEX;

    execute procedure INC_DIGITAL_CNT(:VAR_CLIENT_IP1, :RES_COUNTER_INDEX, RES_COUNTER_SUM_VALUE);
    RES_STR_RESULT = 'Merging values for '||:RES_COUNTER_INDEX||' to '||:VAR_CLIENT_IP1||' COUNTERS_TABLE';
    RES_RESULT=1;
    suspend;
end
RES_COUNTER_SUM_VALUE = 0;
RES_COUNTER_INDEX = 0;
RES_STR_RESULT = 'Values merged successfuly in '||:VAR_CLIENT_IP1||' COUNTERS_TABLE';
RES_RESULT=0;
suspend;
END
^

set term ; ^
commit work;

